/*** CS2DM.H ***********************************************************
 *
 * (C) Copyright IBM Corporation 1991-1996. All rights reserved.
 *
 * Description:
 *   DDMS C Declarations Include File for DAE
 *
 **********************************************************************/

#if !defined (CS2DM_H)                  /* Allow compiler only one copy   */
#define CS2DM_H                         /* Tag this one already included  */

#ifdef CS2CPLUSPLUS
extern "C" {
#endif

#ifndef NULL
#define NULL  0L
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

/* ͻ
    The following defines are used to make the actual calls to       
    DDMS. All calls are processed through ISSUE_SVC.                 
   ͼ  */

#define SVC_CONNECT          0       /* Connect                          */
#define SVC_DISCONNECT       1       /* Disconnect                       */
#define SVC_CONN_DEF         2       /* Connection definition            */
#define SVC_DOWNLOAD         3       /* Download                         */
#define SVC_UPLOAD           4       /* Upload                           */
#define SVC_COMPARE          5       /* Compare                          */
#define SVC_START            7       /* Start                            */
#define SVC_STOP             8       /* Stop                             */
#define SVC_DEVICE_STATUS    9       /* Get device status                */
#define SVC_DEF_LOAD_CONF   10       /* Define load configuration        */
#define SVC_GET_LOAD_CONF   11       /* Get load configuration           */
#define SVC_DEL_LOAD_CONF   12       /* Delete load configuration        */
#define SVC_CLR_LOAD_CONF   13       /* Clear load configuration         */
#define SVC_LOAD_DEF        14       /* Load device definition           */
#define SVC_SAVE_DEF        15       /* Save device definition           */
#define SVC_GET_NAME_LST    16       /* Get semaphore, variable name list*/
#define SVC_DEF_VAR         17       /* Define remote variable           */
#define SVC_DEF_VAR_LST     18       /* Define list of remote variables  */
#define SVC_DEL_VAR         19       /* Delete remote variable           */
#define SVC_GET_VAR_DEF     20       /* Get remote variable definition or*/
                                     /* list or remote variable names    */
#define SVC_READ_VAR        21       /* Read from a remote variable      */
#define SVC_WRITE_VAR       22       /* Write to a remote variable       */
#define SVC_FILE_CREATE     23       /* DOS file create                  */
#define SVC_FILE_DEL        24       /* DOS file delete                  */
#define SVC_FILE_OPEN       25       /* DOS file open                    */
#define SVC_FILE_CLOSE      26       /* DOS file close                   */
#define SVC_FILE_READ       27       /* DOS file read                    */
#define SVC_FILE_WRITE      28       /* DOS file write                   */
#define SVC_FILE_POINTER    29       /* DOS file random access           */
#define SVC_GET_TIME        30       /* Get system date and time         */
#define SVC_QUERY_RDS       31       /* Query RDS                        */
#define SVC_ABORT           33       /* Abort the request                */
#define SVC_KBD_INPUT       34       /* Keyboard input                   */
#define SVC_CON_DISPLAY     35       /* Console display                  */
#define SVC_DUMMY_PROCESS   36       /* Setup User dummy process         */
#define SVC_TRACE_PROCESS   37       /* Setup Trace process              */
#define SVC_TRACE_SERVICE   38       /* Setup Trace service              */
#define SVC_SEM_REQUEST     39       /* Request for a semaphore          */
#define SVC_SEM_RELEASE     40       /* Release a semaphore              */
#define SVC_SEM_ATTACH      41       /* Attach to a semaphore            */
#define SVC_SEM_DEF         42       /* Define a semaphore               */
#define SVC_SEM_DEL         43       /* Delete a semaphore               */
#define SVC_SEM_STATUS      44       /* Query a semaphore status         */
#define SVC_DEF_DEVICE      45       /* Define physical device           */
#define SVC_BFRD_OPEN       46       /* Buffered Open                    */
#define SVC_BFRD_CLOSE      47       /* Buffered Close                   */
#define SVC_BFRD_READ       48       /* Buffered Read                    */
#define SVC_BFRD_WRITE      49       /* Buffered Write                   */
#define SVC_GET_STRUCT      50       /* Get Structure                    */
#define SVC_REQ_ERR         51       /* Request error handling routine   */
#define SVC_CLEAR_DEF_ENV   52       /* Clear definition environment     */
#define SVC_DEL_CONN_DEF    53       /* Delete connection definition     */
#define SVC_GET_CONN_DEF    54       /* Get connection definition        */
#define SVC_DEL_DEV_DEF     55       /* Delete device definition         */
#define SVC_GET_DEV_DEF     56       /* Get device definition            */
#define SVC_GET_SEM_DEF     57       /* Get semaphore definition         */
#define SVC_LOADONE_DEF     58       /* Load one definition              */
#define SVC_LOAD_HEADER     60       /* Load header                      */
#define SVC_SAVE_HEADER     61       /* Save header                      */
#define SVC_DIAG            62       /* Performs diagnostic functions    */
#define SVC_REMQUERY        63       /* Performs query from remote device*/
#define SVC_MEMSTAT         64       /* Gets scb memory information      */
#define SVC_SETMEM          65       /* Gets additional memory           */
#define SVC_MEASSTRT        66       /* Start measurement tests          */
#define SVC_MEASSTOP        67       /* Stop measurement tests           */
#define SVC_WAITRES         68       /* Wait until resource has changed  */
#define SVC_SIZEOF          69       /* Gets size of a variable          */

/*========================== Begin V1.1 Changes =========================*/

#define SVC_WAIT_FOR_COND   75       /* wait for condition               */
#define SVC_START_POLLING   76       /* start variable poller            */
#define SVC_STOP_POLLING    77       /* stop variable poller             */
#define SVC_REP_VAR_STS     79       /* report variable status           */
#define SVC_RENAME_FILE     80       /* rename file                      */
#define SVC_DEFINE_JOURNAL  81       /* define journal                   */
#define SVC_DELETE_JOURNAL  82       /* delete journal                   */
#define SVC_GET_JOUR_ATTR   83       /* get journal attributes           */
#define SVC_REP_JOUR_STS    84       /* report journal status            */
#define SVC_INIT_JOURNAL    85       /* initialize journal               */
#define SVC_READ_JOURNAL    86       /* read journal                     */
#define SVC_WRITE_JOURNAL   87       /* write journal                    */
#define SVC_DEF_EVENT_COND  88       /* define event condtion            */
#define SVC_DEL_EVENT_COND  89       /* delete event condtion            */
#define SVC_GET_EVENT_COND  90       /* get event condtion attributes    */
#define SVC_REP_EVENT_COND  91       /* report event condtion status     */
#define SVC_ALTER_EVENT_COND 92      /* alter event condtion             */
#define SVC_TRIGGER_EVENT   93       /* trigger event                    */
#define SVC_START_SCAN      94       /* start event scanner              */
#define SVC_STOP_SCAN       95       /* stop event scanner               */
#define SVC_WAIT_CHANGE     97       /* wait on change                   */
/*====================== Begin 1.3.0 Changes ============================*/
#define SVC_GET_RES_DEFN    98       /* get resource data definition     */
/*======================= End 1.3.0 Changes =============================*/
#define SVC_START_MSG       100      /* start message service            */
#define SVC_STOP_MSG        101      /* stop message service             */

/*========================== End V1.1 Changes ===========================*/

/*====================== Begin 1.2.2 Changes ============================*/
#define SVC_DEF_DBD         103      /* Define Deadband                  */
#define SVC_GET_DBD         104      /* Get Deadband Definition          */
#define SVC_DEL_DBD         105      /* Delete Deadband Definition       */
/*======================= End 1.2.2 Changes =============================*/

/*====================== Begin 1.3.0 Changes ============================*/
#define SVC_DEF_VAR_STRUCT  106      /* Define Variable Structure        */
#define SVC_GET_VAR_STRUCT  107      /* Get Var. Structure Definition    */
#define SVC_DEL_VAR_STRUCT  108      /* Delete Var. Structure Definition */
#define SVC_GET_VAR_DEF2    109      /* Get Var. Structure Definition    */
                                     /* supports variable structures     */
#define SVC_READ_VAR_LIST   110      /* New Read List API                */
#define SVC_WRITE_VAR_LIST  111      /* New Write List API               */
#define SVC_WRT_VAR         112      /* New Write remote variable API    */
/*======================= End 1.3 Changes ===============================*/

/* Name  Structure */

#ifdef CS2CPLUSPLUS
typedef struct name_s {
#else
typedef struct name {
#endif
  char *reserved;                       /* Reserved field             */
  char *name;                           /* Symbolic name string       */
} NAME;

/* Request  Data  Structure */

typedef struct rds {
  NAME *originator;                     /* Originator name structure  */
  NAME *destination;                    /* Connection name structure  */
  short ack;                            /* Acknowledgement            */
  long   timeout;                       /* Time in milliseconds before*/
                                        /* --    resuming originator  */
  short  priority;                      /* Request priority (10 - 127)*/
  short user_code;                      /* Return code - field 1      */
  short os_code;                        /* Return code - field 2      */
  short reserve_code;                   /* Return code - field 3      */
#ifdef CS2CPLUSPLUS
  CS2_TMP_OPT_T CS2_FAR *template_opt;  /*  template                  */
#else
  CS2_TMP_OPT_T CS2_FAR *template;      /*  template                  */
#endif
  char reserved[22];                    /* Reserved                   */
} RDS;

/*   check if status is completed  */

extern short d_complete(RDS *);

/*    Calculate the checksum of input data  */

extern void check_sum(unsigned char, short, short, short, unsigned long *);

/*ͻ
   Issue_Svc transfers control to DDMS via a software interrupt.    
  ͼ*/

#ifdef CS2CPLUSPLUS
extern "C" {extern void issue_svc(short, RDS *, char * ,char * ); }
#else
extern void issue_svc(short, RDS *, char * ,char * );
#endif
/*ͻ
                   Program   Control  Instructions                  
  ͼ*/

/* Abort */

extern void d_abort(RDS *);

/* Get   Time   Structure */

typedef struct gtresp {            /* GET TIME RESPONSE STRUCTURE     */
  long second;                     /* Seconds since 0000 UTC 01JAN70  */
  short millisecond;               /* Milliseconds since last second  */
} GTRESP;

#define     d_time(rds, p1, p2)\
        issue_svc(SVC_GET_TIME, (rds), NULL, (char *) (p2))

/* Query   Transaction   Status */

extern void d_query(RDS *);

/* RDS   Transaction   List   Wait */

typedef struct lswrsp {           /* RDS LIST WAIT RESPONSE STRUCTURE */
  RDS *compl_rds;                 /* pointer to complete RDS, if any  */
  short to_status;                /* Timeout status                   */
} LSWRSP;

extern void d_rdslistwait(RDS * *, long *, LSWRSP *);

/*ͻ
                   Device    Managment   Commands                   
  ͼ*/

/* Connect */

/* COMMON CONNECT PARAMETERS                                          */
/* Reserved Field 1                 - Required to be 0                */
/* Reserved Field 2                 - Required to be 0                */
/* Maximum outstanding messages                                       */
/* Maximum message size                                               */
/* Maximum file I/O block size                                        */
/* Reserved Field 3                 - Required to be 0                */
/* Reserved Field 4                 - Required to be 0                */
/* Maximum number of queued reqs                                      */
/* Reserved Field 5                 - Required to be 0                */
/* Reserved Field 6                 - Required to be 0                */
/* Product model and revision code  - Reserved pointer; must be ""    */
/* Detail                           - Required for extended devices   */

#define CNTPRM \
  short reserved1; \
  short reserved2; \
  short out_msg; \
  short max_msg_sz; \
  short max_file_blk; \
  short reserved3; \
  short reserved4; \
  short max_q_req; \
  short reserved5; \
  short reserved6; \
  char *model_num; \
  char *detail

#define MODEL_NUM_SIZE 32  /* Size of model_num buffer in connect response */

typedef struct cntreq {            /* CONNECTION REQUEST STRUCTURE    */
  NAME *connection;                /* Connection structure name       */
  char *def_filenm;                /* Definition file                 */
  short reserved;                  /* Reserved field; must be 0       */
} CNTREQ;

typedef struct cntresp {           /* CONNECTION RESPONSE STRUCTURE   */
  short status;                    /* Status of first detected req    */
  CNTPRM;                          /* Connection parameters           */
} CNTRESP;

extern void d_connect(RDS *, CNTREQ *, CNTRESP *);

/* Connection Definition */

typedef struct cntdreq{            /* CONNECTION DEFINITION STRUCTURE */
  char *reserved;                  /* reserved pointer; must be ""    */
  char *logical_nm;                /* Logical name - 64 chars max     */
  char *dev_nm;                    /* DDMS device name                */
  char *dir_name;                  /* Directory name - 64 chars max   */
  char *def_file;                  /* Definitions file                */
  char *diag_file;                 /* Diagnostic message file         */
  CNTPRM;                          /* Connection parameter structure  */
} CNTDREQ;

#define     d_conndef(rds, p1)\
        issue_svc(SVC_CONN_DEF, (rds), (char *) (p1), NULL)

/* Define Device */

#define  DT_SET         0          /* Set of logical devices          */
#define  DT_LOGICAL     1          /* Logical device                  */
#define  DT_DCS         3          /* DCS task services device        */
#define  DT_DIRECT      4          /* Device managed by RCM task      */
#define  DT_LDIT        5          /* Logical Device Interface Task   */
#define  DT_MMS         6          /* MMS device                      */

typedef struct definitions {       /* DEFINITIONS STRUCTURE           */
  char *reserve1;                  /* reserved pointer; must be ""    */
  char *dev_nm;                    /* DDMS device name                */
  char *phy_nm;                    /* Physical device name            */
  short dev_type;                  /* DDMS device type                */
  char *phy_type;                  /* Physical device type            */
  char *subs;                      /*                                 */
  char *residency;                 /* Location of driver/task         */
  short port_num;                  /* Connected comm port             */
  unsigned char parity;            /* parity                          */
  unsigned char reserve2;          /* reserved byte; must be 0        */
  unsigned char frame_sz;          /* Frame size                      */
  unsigned char stop_bits;         /* Stop bits                       */
  char *protocol;                  /* Protocol                        */
  short station_id;                /* Station identification number   */
  char *attributes;                /* Special attributes              */
  short  baud;                     /* baud rate                       */
  short  max_unsol;                /* unsolicited buffer number       */
  short  unsol_bfr_sz;             /* unsolicited buffer size         */
} DEFINITIONS;

#define     d_defdev(rds, p1)\
        issue_svc(SVC_DEF_DEVICE, (rds), (char *) (p1), NULL)

/* Delete Connection Definition */

typedef struct dcdreq {            /* DELETE CONN DEF REQ STRUCTURE   */
  char *reserved;                  /* Reserved pointer; must be ""    */
  NAME *connection;                /* Connection to be deleted        */
} DCDREQ;

#define     d_delconn(rds, p1)\
        issue_svc(SVC_DEL_CONN_DEF, (rds), (char *) (p1), NULL)

/* Delete Device Definition */

typedef struct dddreq {            /* DELETE DEVICE DEF REQ STRUCTURE */
  char *reserved;                  /* Reserved pointer; must be ""    */
  NAME *dev_nm;                    /* DDMS device name                */
} DDDREQ;

#define     d_deldev(rds, p1)\
        issue_svc(SVC_DEL_DEV_DEF, (rds), (char *) (p1), NULL)

/* Disconnect */

typedef struct dcntreq {           /* DISCONNECT REQUEST STRUCTURE    */
  NAME *connection;                /* Connection structure name       */
  short abortop;                   /* Abort pending ops - 1 yes, 0 no */
} DCNTREQ;


extern void d_disconnect(RDS *, DCNTREQ *);

/* Get Connection Definition */

typedef struct gcdreq {            /* GET CONN DEF REQUEST STRUCTURE  */
  char *reserved;                  /* Reserved pointer; must be ""    */
  NAME *connection;                /* Connection definition to get    */
  short bfr_sz;                    /* Size of returned string buffers */
} GCDREQ;

typedef struct gcdresp {           /* GET CONN DEF RESPONSE STRUCTURE */
  char *dev_nm;                    /* DDMS device name                */
  char *dir_name;                  /* Directory name - 64 chars max   */
  char *def_file;                  /* Variable definitions file       */
  char *diag_file;                 /* Diagnostic message file         */
  CNTPRM;                          /* Connect parms of the connection */
} GCDRESP;

#define     d_getconn(rds, p1, p2)\
        issue_svc(SVC_GET_CONN_DEF, (rds), (char *) (p1), (char *) (p2))

/* Get Device Definition */

typedef struct gddreq {            /* GET DEVICE DEF REQ STRUCTURE    */
  char *reserved;                  /* Reserved pointer; must be ""    */
  NAME *dev_nm;                    /* DDMS device name                */
  short bfr_sz;                    /* Max length of returned strings  */
} GDDREQ;

typedef struct gddresp {           /* GET DEVICE DEF RESP STRUCTURE   */
  char *phy_nm;                    /* Device task name                */
  short dev_type;                  /* DDMS definition type            */
  char *phy_type;                  /* Physical device type            */
  char *subs;                      /* Subordinates                    */
  char *residency;                 /* Location of driver/task         */
  short port_num;                  /* Connected comm port             */
  unsigned char parity;            /* parity                          */
  unsigned char reserve2;          /* reserved byte; will be 0        */
  unsigned char frame_sz;          /* Frame size                      */
  unsigned char stop_bits;         /* Stop bits                       */
  char *protocol;                  /* Protocol                        */
  short station_id;                /* Station identification number   */
  char *attributes;                /* Special attributes              */
  short  baud;                     /* baud rate                       */
  short  max_unsol;                /* unsolicited buffer number       */
  short  unsol_bfr_sz;             /* unsolicited buffer size         */
} GDDRESP;

#define     d_getdev(rds, p1, p2)\
        issue_svc(SVC_GET_DEV_DEF , (rds), (char *) (p1), (char *) (p2))

/* Load Definitions */

                                   /* The following defines are used  */
                                   /* to retrieve scope or definition */
                                   /* according to bits masked        */

#define MSK_GLOBAL      0x1L       /* Mask first bit in option        */
#define MSK_LOCAL       0x2L       /* Mask second bit in option       */
#define MSK_CONNECT     0x4L       /* Mask third bit in option        */
#define MSK_DEVICE      0x8L       /* Mask fourth bit in option       */
#define MSK_NETWORK     0x10L      /* Mask fifth bit in option   V1.1 */
#define MSK_VAR_STRUCT  0x20L      /* Mask sixth bit in option   v1.3 */
#define SKIP_AND_NOTIFY 0          /* Dup option of skip and notify   */

typedef struct ldreq {             /* LOAD DEFINITION REQUEST         */
  char *filenm;                    /* DOS file w/ rem var and sem defs*/
  long  options;                   /* See MSK_ defines for options    */
  short dup_option;                /* duplicate condition options     */
  short bfr_sz;                    /* Maximum size of recieve buffer  */
} LDREQ;

typedef struct ldresp {            /* LOAD DEFINITION RESPONSE        */
  short count;                     /* Count out                       */
  char *buffer;                    /* Buffer out                      */
} LDRESP;

#define     d_loaddef(rds, p1, p2)\
        issue_svc(SVC_LOAD_DEF, (rds), (char *) (p1), (char *) (p2))

/* Save Definitions */

typedef struct sdreq {             /* LOAD DEFINITION REQUEST         */
  char *filenm;                    /* DOS file w/ rem var and sem defs*/
  long  options;                   /* See MSK_ defines for options    */
} SDREQ;

#define     d_savedef(rds, p1)\
        issue_svc(SVC_SAVE_DEF, (rds), (char *) (p1), NULL)

/* Clear   Definition   Enviroment */

                                   /* Mask for test rds oscode        */
                                   /* TRUE if resource(s) in use      */

#define local_in_use(oscode)          ( (oscode) & MSK_LOCAL )
#define global_in_use(oscode)         ( (oscode) & MSK_GLOBAL )
#define network_in_use(oscode)        ( (oscode) & MSK_NETWORK )

/* Request: address of option */      /* Options parameter */

#define     d_cleardef(rds, p1)\
        issue_svc(SVC_CLEAR_DEF_ENV, (rds), (char *) (p1), NULL)


/*ͻ
               Device   Program   Support   Commands                
  ͼ*/

/* Clear Load Configuration */

#define     d_clrload(rds, p1)\
        issue_svc(SVC_CLR_LOAD_CONF, (rds), (char *) (p1), NULL)

/* Compare */

typedef struct compareq {          /* COMPARE REQUEST                 */
  char *filenm;                    /* Ptr to (path/)name or file list */
  short reqsz;                     /* Error response bytes desired    */
} COMPAREQ;

typedef struct comparesp {         /* COMPARE RESPONSE STRUCTURE      */
  short errorcnt;                  /* Total error count               */
  char *response;                  /* Error fields :                  */
                                   /* LIST mode will contain name(s)  */
                                   /*      of failing device(s)       */
                                   /*      delimited by a comma       */
                                   /* PRIME mode will contain :       */
                                   /*    n error records depending    */
                                   /*      upon request reqsz value   */
} COMPARESP;

#define     d_compare(rds, p1, p2)\
        issue_svc(SVC_COMPARE, (rds), (char *) (p1), (char *) (p2))


/* Define Load Configuration */

#define  RA_PROTECTED        0x1   /* Region Attribute Bit Positions  */
#define  RA_RELOCATABLE      0x2
#define  RA_RETENTIVE        0x4
#define  RA_SHARABLE         0x8
#define  RA_NODOWNLOAD       0x10
#define  RA_VERIFIABLE       0x20
#define  RA_COMPARABLE       0x40
#define  RA_NOUPLOAD         0x80
#define  RA_DELETABLE       0x100
#define  RA_REUSABLE        0x200

typedef struct region_def {        /* REGION DEFINITION               */
  char *region_name;               /* Region name                     */
  char type;                       /* Region type                     */
  char reserved;                   /* reserved (must be 0)            */
  short attributes;                /* Region attributes               */
  long length;                     /* Region length                   */
  char *address;                   /* Region address                  */
  short addr_type;                 /* See address type #defines       */
} REGION_DEF;

typedef struct dlcreq {            /* DEFINE LOAD CONFIGURATION REQ   */
  char *reserved;                  /* Reserved for future use         */
  char *config_name;               /* Configuration name              */
} DLCREQ;                          /* A list of REGION_DEF structures */
                                   /* follows.  The list is terminated*/
                                   /* by a NULL pointer.              */

#define     d_defload(rds, p1)\
        issue_svc(SVC_DEF_LOAD_CONF, (rds), (char *) (p1), NULL)

/* Delete Load Configuration */

typedef struct delcreq {           /* DELETE LOAD CONFIGURATION REQ   */
  char *reserved;                  /* Reserved for future use         */
  char *config_name;               /* Configuration name              */
} DELCREQ;

#define     d_delload(rds, p1)\
        issue_svc(SVC_DEL_LOAD_CONF, (rds), (char *) (p1), NULL)

/* Download */

typedef struct dlreq {             /* DOWNLOAD REQUEST                */
  char *filenm;                    /* Ptr to (path/)name or file list */
  short start;                     /* 1 start, 0 no, if list ignore   */
  short verify;                    /* 1 compare, 0 no, if list ignore */
  short respsz;                    /* Error response size in bytes    */
} DLREQ;

typedef struct dlerror {           /* DOWNLOAD RESPONSE STRUCTURE     */
  short errorcnt;                  /* Total error count               */
  char *response;                  /* Error fields :                  */
                                   /* LIST mode will contain name(s)  */
                                   /*      of failing device(s)       */
                                   /*      delimited by a comma       */
                                   /* PRIME mode will contain :       */
                                   /*    n error records depending    */
                                   /*      upon request respsz value  */
} DLERROR;


#define     d_download(rds, p1, p2)\
        issue_svc(SVC_DOWNLOAD, (rds), (char *) (p1), (char *) (p2))

/* Get Device Status */

typedef struct dsresp {            /* GET DEVICE STATUS RESPONSE      */
  short status;                    /* Program status, 0 stop, 1 run   */
  short count;                     /* Bytes returned in hw array      */
  char hw_status[128];             /* Physical device status          */
} DSRESP;

#define     d_devstatus(rds, p1, p2)\
        issue_svc(SVC_DEVICE_STATUS, (rds), NULL, (char *) (p2))

/* Get Name List */

#define NT_LOCAL_VARS      0
#define NT_GLOBAL_VARS     1
#define NT_SEMAPHORES      4
#define NT_LOCAL_JRNLS     6
#define NT_GLOBAL_JRNLS    7    /* V1.1 */
#define NT_LOCAL_EVTCON    8    /* V1.1 */
#define NT_GLOBAL_EVTCON   9    /* V1.1 */
#define NT_NETWORK_EVTCON 10    /* V1.1 */
#define NT_LOAD_CONFS     11
#define NT_CONNECTIONS    12
#define NT_DEVICES        13
#define NT_VAR_STRUCT     14    /* V1.3 */

typedef struct gnreq {
  short name_type;                 /* See NT defines                  */
  char *last_name;                 /* Name received on prev request   */
  short max_names;                 /* Max number of names to receive  */
  short bfr_sz;                    /* Length of the output buffer     */
  } GNREQ;

/* Response:  pointer to char (buffer of resource names) */

#define     d_getnames(rds, p1, p2)\
        issue_svc(SVC_GET_NAME_LST, (rds), (char *) (p1), (char *) (p2))

/* Get Load Configuration */

typedef struct glcreq {            /* GET LOAD CONFIGURATION REQUEST  */
  char *reserved;                  /* Reserved for future use         */
  char *config_name;               /* Configuration name              */
  char *start;                     /* Return information on regions   */
                                   /*   following this region name    */
  short size;                      /* Max size of receiving buffer    */
} GLCREQ;

typedef struct glcresp {           /* GET LOAD CONFIGURATION RESPONSE */
  short count;                     /* Number of bytes returned in buf */
  char *regions;                   /* Buffer to contain region info   */
} GLCRESP;

#define     d_getload(rds, p1, p2)\
        issue_svc(SVC_GET_LOAD_CONF, (rds), (char *) (p1), (char *) (p2))

/* Start a Device Program */

 typedef struct strpgreq {         /* Start Program REQUEST          */
      char  *load_config;          /* Valid Load Configuration File  */
      char  *options;              /* Optional parameters            */
      char  *detail;               /* Detail string                  */
      char  *reserved;             /* reserved field                 */
 } STRPGREQ;

#define     d_startpgm(rds, p1, p2)\
        issue_svc(SVC_START, (rds), (char *) (p1), NULL)

/*  Stop a Device Program */

 typedef struct stppgreq {         /* Stop  Program REQUEST          */
      char *load_config;           /* Valid Load Configuration File  */
      char *options;               /* Optional parameters            */
      char *detail;                /* Detail string                  */
      char *reserved;              /* reserved field                 */
 } STPPGREQ;

#define     d_stoppgm(rds, p1, p2)\
        issue_svc(SVC_STOP, (rds), (char *) (p1), NULL)

/* Upload */

typedef struct ulreq  {            /* Upload Request Structure        */
     char *filenm ;                /* DOS file to contain uploaded pgm*/
     short respz  ;                /* Response buffer size            */
} ULREQ ;

typedef struct ulresp   {          /* Upload Response Structure       */
     char *bfr_addr ;              /* Name (logical) of failing device*/
} ULRESP ;

#define     d_upload(rds, p1, p2)\
        issue_svc(SVC_UPLOAD, (rds), (char *) (p1), (char *) (p2))

/*ͻ
                    Remote   Variable   Commands                    
  ͼ*/

/*
** Valid scope values for Variables, Event Conditions and Journals.
*/
#define SCOPE_GLOBAL 0             /*   Global resource definitions   */
#define SCOPE_LOCAL  1             /*   Local resource definitions    */
#define SCOPE_DOMAIN 2             /*   Domain resource definitions   */

/* Define List of Remote Variables */

typedef struct drvlreq {           /* DEFINE LIST OF REM VAR REQUEST  */
  char *attributes;                /* Attributes            - V1.3    */
  NAME *list;                      /* Ptr to name of variable list    */
  short scope;                     /* See scope defines               */
  short bfr_sz;                    /* Size of holding buffer          */
  NAME *varnm;                     /* Pointers to name structure that */
                                   /* are members of this variable    */
                                   /* list. Each name structure has   */
                                   /* variable name associated with   */
                                   /* it. End of list is a NULL ptr.  */
} DRVLREQ;

/* Request:  address of DRVLREQ structure */

/* Response: none */

#define     d_deflrvar(rds, p1)\
        issue_svc(SVC_DEF_VAR_LST, (rds), (char *) (p1), NULL)

/* Deadband Information Structure */
/*
** Valid dbd_type values for deadbanding used in DBDINFO structure
*/
#define DBD_TYPE_ABS_FL_REF    0   /* Absolute Floating Reference Deadband  */
#define DBD_TYPE_PER_FL_REF    1   /* Percent Floating Reference Deadband   */
#define DBD_TYPE_USER_REF      2   /* User Defined Reference deadbanding    */
#define DBD_TYPE_NO_DBD        3   /* No Deadbanding for this array element */
#define DBD_TYPE_UPD_NO_MSG    4   /* Variable's data will be updated if it */
                                   /* changed but no message notification   */
                                   /* will be send to the ACB or MCB        */

typedef struct dbdinfo {           /* DEADBAND INFO STRUCTURE         */
  char  dbd_type;                  /* See dbd_type defines            */
  float dbd_high;                  /* Deadband high (upper bound)     */
  float dbd_low;                   /* Deadband low  (lower bound)     */
} DBDINFO;

/* Define Deadband */
/*
** The following #defines reflect position of the parameters within the
**   define deadband request structure
*/
#define DD_VARNM          1
#define DD_COUNT          2
#define DD_DEADBANDS      3
#define DD_RESERVED       4
#define DD_RESERVED2      5

typedef struct ddbdreq {           /* DEFINE DEADBAND REQ STRUCTURE   */
  NAME *varnm;                     /* Variable to apply deadband to   */
  short count;                     /* Number of elements in array of  */
                                   /* DBDINFO, 1 if var is not array  */
  DBDINFO *deadbands;              /* pointer to deadband information */
  short    default_type;           /* default deadbanding type        */
  char    *reserved2;              /* Reserved; set to NULL           */
} DDBDREQ;

/* Request:  address of DDBDREQ structure */

/* Response: none */

#define     d_defdbd(rds, p1)\
        issue_svc(SVC_DEF_DBD, (rds), (char *) (p1), NULL)

/* Delete Deadband */
/*
** The following #defines reflect position of the parameters within the
**   delete deadband request structure
*/
#define DLD_VARNM          1
#define DLD_RESERVED       2
#define DLD_RESERVED2      3

typedef struct dldbdreq {          /* DELETE DEADBAND REQ STRUCTURE   */
  NAME *varnm;                     /* Variable to delete deadbanding  */
  short default_type;              /* default deadbanding type        */
  char *reserved2;                 /* Reserved; set to NULL           */
} DLDBDREQ;

/* Request:  address of DLDBDREQ structure */

/* Response: none */

#define     d_deldbd(rds, p1)\
        issue_svc(SVC_DEL_DBD, (rds), (char *) (p1), NULL)

/* Get Deadband Definition */
/*
** The following #defines reflect position of the parameters within the
**   get deadband request structure
*/
#define GD_VARNM          1
#define GD_BFR_SZ         2
#define GD_RESERVED       3
#define GD_RESERVED2      4

typedef struct gdbdreq {           /* GET DEADBAND REQ STRUCTURE      */
  NAME *varnm;                     /* Variable to apply deadband to   */
  short bfr_sz;                    /* Response Buffer Size (in bytes) */
  short reserved;                  /* Reserved; set to 0              */
  char *reserved2;                 /* Reserved; set to NULL           */
} GDBDREQ;

typedef struct gdbdresp {          /* GET DEADBAND RESP STRUCTURE     */
  short count;                     /* Number of elements in array of  */
                                   /* DBDINFO, 1 if var is not array  */
  DBDINFO *deadbands;              /* pointer to deadband information */
  short reserved;                  /* Reserved; set to 0              */
  char *reserved2;                 /* Reserved; set to NULL           */
} GDBDRESP;

/* Request:  address of GDBDREQ structure */

/* Response: address of GDBDRESP structure */

#define     d_getdbd(rds, p1, p2)\
        issue_svc(SVC_GET_DBD, (rds), (char *) (p1), (char *) (p2))



/*====================== Begin 1.3.0 Changes ============================*/

/*  MEMBER INFO STRUCTURE USED TO DEFINE A VARIABLE STRUCTURE  */

typedef struct member_info
{
  char  appl_member_name [16];
  short appl_data_type;
  short appl_data_length;
  short appl_nmbr_elems;
  char  dev_member_name [16];
  short dev_data_type;
  short dev_data_length;
  short dev_nmbr_elems;
} MEMBER_INFO;

/* defines used for variable structure */

#define  END_OF_STRUCT  "END_OF_STRUCT"
#define  STRUCT         "STRUCT"

/* Define Variable Structure */

typedef struct dvsreq {              /* DEFINE VAR. STRUCTURE REQUEST */
  NAME        *structnm;             /* name of structure             */
  MEMBER_INFO *member_defs;          /* pointer to member info.       */
  short        reserved;             /* Reserved; set to 0            */
  char        *reserved2;            /* Reserved; set to NULL         */
} DVSREQ;

#define     d_defvstr(rds, p1)\
        issue_svc(SVC_DEF_VAR_STRUCT, (rds), (char *) (p1), NULL)


/* Get Variable Structure */

typedef struct gvsreq {            /* GET VAR. STRUCTURE REQUEST      */
  NAME   *structnm;                /* name of variable structure      */
  short  bfr_sz;                   /* Response Buffer Size (in bytes) */
  short  reserved;                 /* Reserved; set to 0              */
  char  *reserved2;                /* Reserved; set to NULL           */
} GVSREQ;

typedef struct gvsresp {            /* GET VAR. STRUCTURE RESPONSE     */
  char        *structnm;            /* name of variable structure      */
  MEMBER_INFO *member_defs;         /* pointer to structure info.      */
  short        reserved;            /* Reserved; set to 0              */
  char        *reserved2;           /* Reserved; set to NULL           */
} GVSRESP;

#define     d_getvstr(rds, p1, p2)\
        issue_svc(SVC_GET_VAR_STRUCT, (rds), (char *) (p1), (char *) (p2))

/* Delete Variable Structure */

typedef struct dlvsreq {           /* DELETE VAR. STRUCTURE REQUEST   */
  NAME   *structnm;                /* name of structure               */
  short   reserved;                /* Reserved; set to 0              */
  char   *reserved2;               /* Reserved; set to NULL           */
} DLVSREQ;

#define     d_delvstr(rds, p1)\
        issue_svc(SVC_DEL_VAR_STRUCT, (rds), (char *) (p1), NULL)

/* Get Resource Data Definition*/
typedef struct gdareq {           /* GET RES. DATA DEFN REQUEST STRUCTURE */
  NAME   *resname;                /* Pointer to resource name             */
  char   *reserved;               /* reserved; set to ""                  */
  char   reserved2;               /* reserved; set to 0                   */
} GDAREQ;

typedef struct gdaresp {          /* GET RES. DATA DEFN RESPONSE STRUCTURE*/
  char res_type;                  /* Resource type.                       */
  char data_type;                 /* The type of the resource data        */
  short element_len;              /* Length of one element (in bytes)     */
  short element_no;               /* Number of elements                   */
  short reserved;                 /* reserved; set to 0                   */
  char  *reserved2;               /* reserved; set to NULL                */
} GDARESP;

#define     d_getresdef(rds, p1, p2)\
    issue_svc(SVC_GET_RES_DEFN, (rds), (char *) (p1), (char *) (p2))

/*====================== end 1.3.0 Changes ============================*/

/* Define Remote Variables */

                                   /*       data region defines       */
#define DR_MEMORY     0            /* memory reference                */
#define DR_IO_TABLE   1            /* i/o table reference             */
#define DR_UNSOL_MSG  2            /* unsolicited messages            */
#define DR_HOLD_VAR   3            /* holding variable                */

#define AT_SYMBOLIC   0            /* address type symbolic           */
#define AT_LOGICAL    1            /* address type logical            */
#define AT_PHYSICAL   2            /* address type physical           */

                                   /* DATA/ADDRESS DISPLAY OPTIONS    */
#define DC_HEX        0            /* display in hexadecimal format   */
#define DC_DECIMAL    1            /* display in decimal format       */
#define DC_OCTAL      2            /* display in octal format         */

                                   /* DATA DISPLAY OPTIONS            */
#define DC_BIN        3            /* display in binary format        */

                                   /* use by menu when displaying address */
#define DT_CHAR_STRING 0           /* character string                    */
#define DT_BYTE        1           /* byte                                */
#define DT_INTEGER     2           /* integer                             */
#define DT_FLOATING_PT 3           /* floating point integer              */
#define DT_BOOLEAN     4           /* boolean                             */
#define DT_TIME_ASCII  5           /* time ascii coded                    */
#define DT_TIME_BIN    6           /* binary value of time: long & short  */
#define DT_BIN_CODED_DEC  7        /* binary coded decimal                */
#define DT_STRUCTURE      8        /* Structure for 1.3                   */

typedef struct drreq {             /* DEFINE REMOTE VARIABLE REQUEST  */
  char *attributes;                /* structure name        v1.3      */
  short scope;                     /* See scope defines               */
  NAME *varnm;                     /* Variable name structure         */
  short data_region;               /* See data region defines         */
  short dev_data_type;             /* Element type on device          */
  char addr_type;                  /* See address type #defines       */
  char addr_dsply;                 /* See display characteristic defs */
  char *sym_log_addr;              /* Symbolic/logical address        */
  long phys_addr;                  /* Physical address                */
  long offset_addr;                /* Offset address                  */
  short bitoffset_addr;            /* Bit offset for Boolean variable */
  char data_type;                  /* See Data Type defines           */
  char data_dsply;                 /* See display characteristic defs */
  short elements_no;               /* Number of elements (>1 = array) */
  short element_len;               /* Length of one element in bytes  */
  long poll_rate;                  /* Variable poll rate         V1.1 */
  float reserved2;                 /* Reserved float; must be 0.0     */
  float reserved3;                 /* Reserved float; must be 0.0     */
  char *data;                      /* Variable length data area       */
} DRREQ;

/* Request:  address of DRREQ structure */

/* Response: none */

#define     d_defrvar(rds, p1)\
        issue_svc(SVC_DEF_VAR, (rds), (char *) (p1), NULL)

/* Delete  Remote  Variable  Definition */

typedef struct delreq {            /* DELETE REMOTE VARIABLE REQUEST  */
  char *reserved;                  /* Reserved pointer; must be ""    */
  NAME *name_str;                  /* Variable name structure         */
} DELREQ;

/* Request:  address of DELREQ structure */

/* Response: none */

#define     d_delrvar(rds, p1)\
        issue_svc(SVC_DEL_VAR, (rds), (char *) (p1), NULL)

/* Get Variable Definition */

#define GV_PRIME 0
#define GV_LIST  1

typedef struct grvreq {            /* GET REMOTE VAR DEF REQUEST      */
  char *reserved;                  /* Reserved pointer; must be ""    */
  NAME *varnm;                     /* Symbolic name                   */
  short bfr_sz;                    /* Buffer size                     */
} GRVREQ;

typedef struct grvresp {           /* GET REMOTE VAR DEF RESPONSE     */
  short type;                      /* Type out                        */
  short scope;                     /* see Scope #defines              */
                                   /* NOTE: ALL is not a viable option*/
  char *var_nm;                    /* Variable name                   */
  short data_region;               /* Data region                     */
  short dev_data_type;             /* Element type on device          */
  char addr_type;                  /* see Address Type #defines       */
  char addr_dsply;                 /* See display characteristic defs */
  char *sym_log_addr;              /* Symbolic/logical address        */
  long phys_addr;                  /* Physical address                */
  long offset_addr;                /* Offset address                  */
  short bitoffset_addr;            /* Bit offset for Boolean variable */
  char data_type;                  /* See Data Type defines           */
  char data_dsply;                 /* See display characteristic defs */
  short elements_no;               /* Number of elements (>1 = array) */
  short element_len;               /* Length of one element in bytes  */
  long poll_rate;                  /* Variable poll rate         V1.1 */
  float reserved2;                 /* Reserved float; must be 0.0     */
  float reserved3;                 /* Reserved float; must be 0.0     */
} GRVRESP;

/* Request:  address of GRVREQ structure */

/* Response: address of GRVRESP structure */

#define     d_getrvar(rds, p1, p2)\
        issue_svc(SVC_GET_VAR_DEF, (rds), (char *) (p1), (char *) (p2))

/* Get Variable Definition2 - supports structures - 1.3 */

typedef struct gvdreq {            /* GET VAR DEFINITION REQUEST      */
  NAME *varnm;                     /* Symbolic name                   */
  short bfr_sz;                    /* Buffer size                     */
  short member_count;              /* number of member_info structures */
  short reserved;                  /* Reserved; set to 0               */
  char  *reserved2;                /* Reserved; set to NULL            */
} GVDREQ;

typedef struct gvdresp {           /* GET VAR DEFINITION RESPONSE     */
  short type;                      /* Type out                        */
  short scope;                     /* see Scope #defines              */
                                   /* NOTE: ALL is not a viable option*/
  char *var_nm;                    /* Variable name                   */
  char *attributes;                /* attributes of the variable      */
  short data_region;               /* Data region                     */
  short dev_data_type;             /* Element type on device          */
  char addr_type;                  /* see Address Type #defines       */
  char addr_dsply;                 /* See display characteristic defs */
  char *sym_log_addr;              /* Symbolic/logical address        */
  long phys_addr;                  /* Physical address                */
  long offset_addr;                /* Offset address                  */
  short bitoffset_addr;            /* Bit offset for Boolean variable */
  char data_type;                  /* See Data Type defines           */
  char data_dsply;                 /* See display characteristic defs */
  short elements_no;               /* Number of elements (>1 = array) */
  short element_len;               /* Length of one element in bytes  */
  long poll_rate;                  /* Variable poll rate         V1.1 */
  MEMBER_INFO *member_defs;        /* defines structure definition    */
  short reserved;                  /* Reserved; set to 0               */
  char  *reserved2;                /* Reserved; set to NULL            */
} GVDRESP;


#define     d_getvdef(rds, p1, p2)\
        issue_svc(SVC_GET_VAR_DEF2, (rds), (char *) (p1), (char *) (p2))

/* Report Variable Status  V1.1 */

typedef struct rvsreq {           /* REPORT VAR STATUS REQUEST       */
  NAME *name;                     /* Pointer to the variable name    */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} RVSREQ;

typedef struct rvsresp {          /* REPORT VAR STATUS RESPONSE      */
  char poll_err;                  /* If true, it indicates if there  */
                                  /* was an error on the last read   */
                                  /* (poll) of this variable.        */
  char poll_active;               /* If true, it indicates if polling*/
                                  /* is currently active.            */
  char poll_missed;               /* If true, it indicates at least  */
                                  /* poll cycle was missed.          */
  char reserved1;                 /* Reserved; Set to zero.          */
  short reserved2;                /* Reserved; Set to zero.          */
  short reserved3;                /* Reserved; Set to zero.          */
  short reserved4;                /* Reserved; Set to zero.          */
  short reserved5;                /* Reserved; Set to zero.          */
  unsigned char *reserved6;       /* Reserved; must be NULL          */
} RVSRESP;

/* Request:  address of RVSREQ structure */

/* Response: address of RVSRESP structure */

#define     d_varstatus(rds, p1, p2)\
        issue_svc(SVC_REP_VAR_STS, (rds), (char *) (p1), (char *) (p2))

/* Read Remote Variables */

#define SO_LAST      0             /* Return last saved value         */
#define SO_FRESH     1             /* Return fresh data               */
#define SO_CONDFRESH 2             /* Conditionally, ret fresh data   */
#define SO_NODEADBAND 3            /* Disregard deadbanding for read  */

typedef struct rrvreq {            /* READ REMOTE VARIBLE REQUEST     */
  NAME *varnm;                     /* Symbolic name                   */
  short save_op;                   /* Save option - see OP_ defines   */
  GTRESP timestamp;                /* Time stamp                      */
  short bfr_sz;                    /* buffer size                     */
} RRVREQ;

typedef struct rrvresp {           /* READ REMOTE VARIABLE RESPONSE   */
  short count;                     /* Number of bytes read            */
  char *bfr_addr;                  /* Ptr to buffer address           */
  GTRESP timestamp;                /* time stamp                      */
} RRVRESP;

/* Request:  address of RRVREQ structure */

/* Response: address of RRVRESP structure */

extern unsigned char direct_data_copy(RDS *,RRVREQ *,RRVRESP *);

#define     d_readrvar(rds, p1, p2)\
        if (! direct_data_copy (rds, p1, p2)) \
        issue_svc(SVC_READ_VAR, (rds), (char *) (p1), (char *) (p2))

/* Write Remote Variables */

typedef struct wrvreq {            /* WRITE REMOTE VARIABLE REQUEST */
  NAME *varnm;                     /* Symbolic name                 */
  short bfr_sz;                    /* Buffer size                   */
  char *bfr_addr;                  /* Ptr to buffer address         */
} WRVREQ;

/* Request:  address of WRVREQ structure */

/* Response: none */

#define     d_writervar(rds, p1)\
        issue_svc(SVC_WRITE_VAR, (rds), (char *) (p1), NULL)


/* NEW Write Remote Variables - V1.3 */

typedef struct wvreq {         /* NEW WRITE REMOTE VARIABLE REQUEST     */
  NAME  *varnm;                /* Symbolic name                         */
  short bfr_sz;                /* buffer size                           */
  char  *bfr_addr;             /* Ptr to buffer address                 */
  char  *attributes;           /* contains keywords and their values    */
  short reserved;              /* Reserved; set to 0                    */
  char  *reserved2;            /* Reserved; set to NULL                 */
} WVREQ;

/* Request:  address of WVREQ structure */

/* Response: none */

#define     d_writevar(rds, p1)\
        issue_svc(SVC_WRT_VAR, (rds), (char *) (p1), NULL)


/* Read Variable List  - V1.3 */

/*
** values used for io_options in read and write list command
*/
#define IO_OPT_PERMIT_WRITE     0
#define IO_OPT_INHIBIT_WRITE    1
#define IO_OPT_WRITE_UNDEFINED  2

typedef struct status_info
{
  short primary;
  short secondary;
} STATUS_INFO;

typedef struct rvlreq
{                              /* READ VARIABLE LIST REQUEST                */
  char       *list_names;      /* list name and variable names              */
  char       *attributes;      /* contains keywords and their values        */
  short      buffer_size;      /* size of the receiving buffer for data     */
  short      var_count;        /* number of variables in the list           */
  short      *io_options;      /* array that contains device dependent      */
                               /* codes - one short of each variable        */
#ifdef CS2CPLUSPLUS
  char       *template_opt;    /* template buffer                           */
#else
  char       *template;        /* template buffer                           */
#endif
  short      save_op;          /* 0 = return last value                     */
                               /* 1 = return fresh data                     */
                               /* 2 = conditionally return fresh data       */
                               /* 3 = return fresh data/not deadbanded      */
  GTRESP     timestamp;        /* If save_op = 2 specifies freshness        */
  short      reserved;         /* Reserved; set to 0                        */
  char       *reserved2;       /* Reserved; set to NULL                     */

} RVLREQ;

typedef struct rvlresp
{                              /* READ VARIABLE LIST RESPONSE               */
  STATUS_INFO   *status;       /* Primary and secondary status for each     */
                               /* variable in the list                      */
  char          *data_bfr;     /* Data buffer                               */
  GTRESP        *timestamps;   /* Timestamp for each variable               */
  short         reserved;      /* Reserved                                  */
  char          *reserved2;    /* Reserved                                  */

} RVLRESP;

extern unsigned char rwl_direct_data_copy(RDS *,RVLREQ *,RVLRESP *);

#define d_rdvarlst(rds, p1, p2)\
        if (! rwl_direct_data_copy (rds, p1, p2)) \
         issue_svc(SVC_READ_VAR_LIST, (rds), (char *) (p1),(char *) (p2) )

/* Write Variable List    - V1.3 */

typedef struct wvlreq
{                              /* WRITE VARIABLE LIST REQUEST               */
  char   *list_names;          /* list name and variable names              */
  char   *attributes;          /* contains keywords and their values        */
  short   buffer_size;         /* size of the receiving buffer for data     */
  short   var_count;           /* number of variables in the list           */
  short  *io_options;          /* array that contains device dependent      */
                               /* codes - one short of each variable        */
#ifdef CS2CPLUSPLUS
  char   *template_opt;        /* template buffer                           */
#else
  char   *template;            /* template buffer                           */
#endif
  char   *data_bfr;            /* data buffer                               */
  short  reserved;             /* Reserved; set to 0                        */
  char   *reserved2;           /* Reserved; set to NULL                     */

} WVLREQ;

typedef struct wvlresp
{                              /* WRITE VARIABLE LIST RESPONSE              */
  STATUS_INFO   *status;       /* Primary and secondary status for each     */
                               /* variable in the list                      */
  short         reserved;      /* Reserved;                                 */
  char          *reserved2;    /* Reserved;                                 */
} WVLRESP;

#define d_wrvarlst(rds, p1, p2)\
        issue_svc(SVC_WRITE_VAR_LIST, (rds), (char *) (p1), (char *) (p2))


/*ͻ
                       Semaphore    Commands                        
  ͼ*/

/* Define a Semaphore */

typedef struct dsreq {             /* DEFINE A SEMAPHORE REQ STRUCT   */
  char *reserve1;                  /* Reserved pointer; must be ""    */
  NAME *semname;                   /* Semaphore being defined         */
  NAME *resname;                   /* Resource semaphore will control */
  short max_share_count;           /* number of concurrent owners of  */
                                   /* a semaphore                     */
  char reserve2;                   /* Reserved field; must be 0       */
  char reserve3;                   /* Reserved field; must be 0       */
} DSREQ;

/* Response:  none */

#define     d_defsem(rds, p1)\
        issue_svc(SVC_SEM_DEF, (rds), (char *) (p1), NULL)

/* Get  Semaphore  Definition */

typedef struct gsreq {             /* GET SEMAPHORE DEFINITION REQUEST */
  NAME *semname;                   /* Semaphore containg definitions   */
  short bfr_sz;                    /* Size of the response buffer      */
} GSREQ;

typedef struct gsresp {            /* GET SEMAPHORE DEFINITION RESPONSE*/
  char *buffer;                    /* Buffer containing resource name  */
  short max_share_count;           /* Number of concurrent users       */
  char reserve1;                   /* Reserved field; must be 0        */
  char reserve2;                   /* Reserved field; must be 0        */
} GSRESP;

#define     d_getsem(rds, p1, p2)\
        issue_svc(SVC_GET_SEM_DEF, (rds), (char *) (p1), (char *) (p2))

/* Delete a Semaphore */

typedef struct dlsreq {            /* DELETE A SEMAPHORE REQ STRUCT   */
  char *reserve1;                  /* Reserved pointer; must be ""    */
  NAME *semname;                   /* Semaphore being deleted         */
} DLSREQ;

/* Response:  none */

#define     d_delsem(rds, p1)\
        issue_svc(SVC_SEM_DEL, (rds), (char *) (p1), NULL)

/* Semaphore Attach */

#define     d_attsem(rds, p1, p2)\
        issue_svc(SVC_SEM_ATTACH, (rds), (char *) (p1), (char *) (p2))

/* Request:  pointer to NAME structure (semaphore name) */

/* Response:  pointer to long (key) */

/* Semaphore Release */

typedef struct rlreq {             /* RELEASE A SEMPHORE REQ STRUCT   */
  NAME *semname;                   /* Semaphore to be released        */
  long *key;                       /* Semaphore key                   */
} RLREQ;

/* Response:  none */

#define     d_relsem(rds, p1)\
        issue_svc(SVC_SEM_RELEASE, (rds), (char *) (p1), NULL)

/* Semaphore Request */

#define     d_reqsem(rds, p1, p2)\
        issue_svc(SVC_SEM_REQUEST, (rds), (char *) (p1), (char *) (p2))

/* Request:  pointer to NAME structure (semaphore name) */

/* Response:  pointer to long (key) */

/* Semaphore Status */

typedef struct ssreq {
  NAME *semname;                   /* Semaphore name for status reques*/
  short bfr_sz;                    /* Buffer size to receive list     */
} SSREQ;                           /* of current owners               */

typedef struct ssresp {
  short status;                    /* 0-locked, others unlocked       */
  char *owner;                     /* Owner(s) if semaphore is in use */
} SSRESP;

#define     d_semstatus(rds, p1, p2)\
        issue_svc(SVC_SEM_STATUS, (rds), (char *) (p1), (char *) (p2))

/*ͻ
                       File         Commands                        
  ͼ*/

#ifdef _WINDOWS_
#define HANDLE HANDL
#endif
typedef char * HANDLE;

/* File Close */

/* Request:  address of HANDLE variable type */

/* Response: none */

#define     d_fileclose(rds, p1)\
        issue_svc(SVC_FILE_CLOSE, (rds), (char *) (p1), NULL)

/* File Create */

/* Request:  pointer(address) to NAME structure for filename */

/* Response: address of HANDLE variable type */

#define     d_filecreate(rds, p1, p2)\
        issue_svc(SVC_FILE_CREATE, (rds), (char *) (p1), (char *) (p2))

/* File Delete */

/* Request:  pointer(address) to NAME structure for filename */

/* Response: none */

#define     d_filedelete(rds, p1)\
        issue_svc(SVC_FILE_DEL, (rds), (char *) (p1), NULL)

/* File Open */

typedef struct foreq {             /* FILE OPEN REQUEST               */
  NAME *file_nm;                   /* file name                       */
  char *direction;                 /* See User manual for options     */
} FOREQ;

/* Request:  address of FOREQ structure */

/* Response: address of HANDLE variable type */

#define     d_fileopen(rds, p1, p2)\
        issue_svc(SVC_FILE_OPEN, (rds), (char *) (p1), (char *) (p2))

/* File Pointer */

#define AC_BEGIN   0               /* Offset from beginning of file   */
#define AC_CURRENT 1               /* Current location plus offset    */
#define AC_EOF     2               /* End of file                     */

typedef struct fpreq {             /* FILE POINTER REQUEST            */
  HANDLE handle;                   /* DDMS file handle                */
  short access;                    /* See AC_ defines                 */
  long offset;                     /* Offset of current file position */
                                   /* from the beginning of the file  */
} FPREQ;

/* Request:  address of FPREQ structure */

/* Response: pointer(address) to long(offset from beginning of file) */

#define     d_fileptr(rds, p1, p2)\
        issue_svc(SVC_FILE_POINTER, (rds), (char *) (p1), (char *) (p2))

/* File Read */

typedef struct frreq {             /* FILE READ REQUEST               */
  HANDLE handle;                   /* DDMS file handle                */
  short x_sz;                      /* Transaction size in bytes       */
} FRREQ;

typedef struct frresp {            /* FILE READ RESPONSE              */
  short count;                     /* Number of bytes actually read   */
  char *bfr_addr;                  /* Buffer to be loaded with data   */
} FRRESP;

/* Request:  address of FRREQ structure */

/* Response: address of FRRESP structure */

#define     d_fileread(rds, p1, p2)\
        issue_svc(SVC_FILE_READ, (rds), (char *) (p1), (char *) (p2))

/* File Write */

typedef struct fwreq {             /* FILE WRITE REQUEST              */
  HANDLE handle;                   /* DDMS file handle                */
  short x_sz;                      /* Transaction size in bytes       */
  char *bfr_addr;                  /* Buffer containing source data   */
} FWREQ;

/* Request:  address of FWREQ structure */

/* Response: pointer(address) to short (bytes actually write) */

#define     d_filewrite(rds, p1, p2)\
        issue_svc(SVC_FILE_WRITE, (rds), (char *) (p1), (char *) (p2))

/* Rename File  V1.1 */

typedef struct rnfreq {           /* RENAME FILE REQUEST             */
  NAME *old_name;                 /* Pointer to the old file object  */
                                  /* name structure.                 */
  NAME *new_name;                 /* Pointer to the new file object  */
                                  /* name structure.                 */
} RNFREQ;

/* Request:  address of RNFREQ structure */

/* Response: none  */

#define     d_filerename(rds, p1)\
        issue_svc(SVC_RENAME_FILE, (rds), (char *) (p1), NULL)

/*ͻ
                      Journaling Commands                      V1.1 
  ͼ*/

/* Journal Data Structures */

#define JRN_ENT_ID_LEN       8   /* Journal Entry Id length          */
#define JRN_DATA_ALIGN_SIZE  4   /* Size of the data overlay portion */
                                 /* of the JOUR_ENT structure.       */

typedef struct rdjheader {       /* JOURNAL ENTRY HEADER STRUCTURE   */
  short  entry_len;              /* Length of the journal entry      */
  short  appl_nm;                /* Offset to Application name string*/
  long   time_second;            /* Timestamp of entry-Seconds       */
  short  time_millisecond;       /* Timestamp of entry-Milliseconds  */
  short  addl_det;               /* Additional Detail; reserved      */
  long   ent_offset;             /* Offset of the entry in the file  */
  char   ent_id[JRN_ENT_ID_LEN]; /* Specifies an entry identifier    */
  char   ent_form;               /* Journal Entry form               */
  char   reserved1;              /* Reserved                         */
  short  reserved2;              /* Reserved                         */
  short  data_len;               /* Data length.  Only valid if entry*/
                                 /* form is RAW_DATA_FORM.           */
  short  reserved3;              /* Reserved                         */
  char data[JRN_DATA_ALIGN_SIZE];/* Data area.  Templates for this   */
                                 /* area are specified by RDJANN,    */
                                 /* RDJRDAT and RDJDATA.             */
} RDJHEADER;

/*
** Journal Entry constants used to define entry form.
*/

#define ANNOTATION_FORM 1        /* User specified text string      */
#define RAW_DATA_FORM   2        /* User specified byte array       */
#define DATA_FORM       3        /* Event/Variable data form        */

typedef struct rdjann {          /* JOURNAL ANNOTATION DATA          */
  char annotation[1];            /* Annotation; a null terminated    */
                                 /* character string.                */
} RDJANN;

typedef struct rdjrdat {         /* JOURNAL RAW DATA                 */
  unsigned char raw_data[1];     /* Raw data byte stream whose length*/
                                 /* is determined by data_len        */
} RDJRDAT;

typedef struct rdjvar {          /* JOURNAL VARIABLE LIST ELEMENT    */
  short var_name;                /* Offset to variable name string   */
  short var_type;                /* Variable data type               */
  short var_length;              /* Variable data length             */
  short var_elem;                /* Number of data_type elements     */
  short var_value;               /* Offset to the variable data      */
} RDJVAR;

typedef struct rdjdata {         /* JOURNAL DATA                     */
  short  ev_nm;                  /* Offset to event name string      */
  char   cur_state;              /* Current state of the event       */
  char   reserved4;              /* Reserved                         */
  short  var_count;              /* Number of times the RDJVAR       */
                                 /* structure is repeated.           */
  RDJVAR var_list[1];            /* Variable list begins here and is */
                                 /* described by RDJVAR.             */
} RDJDATA;

/* Define Journal */

typedef struct cjreq {            /* DEFINE JOURNAL REQUEST          */
  NAME *name;                     /* Pointer to the journal name     */
  char scope;                     /* Scope of the journal.           */
  char deletable;                 /* If true, it indicates whether   */
                                  /* that this Journal cannot be     */
                                  /* deleted.                        */
  char location;                  /* Indicates location of journal   */
  char init_file;                 /* If true, it indicates that an   */
                                  /* existing file with the same name*/
                                  /* should be intialized when opened*/
  char *file_obj;                 /* Pointer to a null terminated    */
                                  /* character string which contains */
                                  /* the fully qualified path name   */
                                  /* of the journal file.            */
  short max_ent_size;             /* Maximum length of each journal  */
                                  /* entry.                          */
  long max_size;                  /* Maximum number of journal       */
                                  /* entries allowed in the journal. */
  unsigned char *addl_det;        /* additional detail; reserved     */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} CJREQ;

/*
** Constants used for location, and minimum and maximum entry size
** and journal size.  Note: See Remote Variable Commands
** for the scope constants.
*/

#define LOC_MEMORY_RES 1         /* Journal is memory resident       */
#define LOC_DISK_RES   2         /* Journal is disk resident         */

#define JRN_MIN_SIZ_ENTRY     sizeof(RDJHEADER) + (2 * sizeof(char))
#define JRN_MAX_SIZ_ENTRY     32759

#define JRN_MIN_NUM_ENTRIES   1
#define JRN_MAX_NUM_ENTRIES   2147483647

#define NO_SIZE_LIMIT  0         /* No limit on journal size         */

/* Request:  address of CJREQ structure */

/* Response: none */

#define     d_defjrnl(rds, p1)\
        issue_svc(SVC_DEFINE_JOURNAL, (rds), (char *) (p1), NULL)

/* Delete Journal */

typedef struct djreq {            /* DELETE JOURNAL REQUEST          */
  NAME *name;                     /* Pointer to the journal name     */
  char del_file;                  /* If true, it indicates that the  */
                                  /* file which contains the journal */
                                  /* entries dshould be deleted.     */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} DJREQ;

/* Request:  address of DJREQ structure */

/* Response: none */

#define     d_deljrnl(rds, p1)\
        issue_svc(SVC_DELETE_JOURNAL, (rds), (char *) (p1), NULL)

/* Get Journal Attributes */

typedef struct gjreq {            /* GET JOURNAL ATTRIBUTES REQUEST  */
  NAME *name;                     /* Pointer to the journal name     */
  short buf_size;                 /* Maximum size of the output field*/
                                  /* file_obj.                       */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} GJREQ;

typedef struct gjresp {           /* GET JOURNAL ATTRIBUTES RESPONSE */
  char scope;                     /* Scope of the journal resource   */
  char deletable;                 /* If true, it indicates whether   */
                                  /* that this Journal cannot be     */
                                  /* deleted.                        */
  char location;                  /* Indicates location of journal   */
  char init_file;                 /* If true, it indicates that an   */
                                  /* existing file with the same name*/
                                  /* should be intialized when opened*/
  char *file_obj;                 /* Pointer to a null terminated    */
                                  /* character string in which the   */
                                  /* fully qualified path name of the*/
                                  /* journal file is returned. This  */
                                  /* buffer must be of file_obj_size */
                                  /* length.                         */
  short max_ent_size;             /* Maximum length of each journal  */
                                  /* entry.                          */
  long max_size;                  /* Maximum number of journal       */
                                  /* entries allowed in the journal. */
  unsigned char *addl_det;        /* additional detail; reserved     */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} GJRESP;

/* Request:  address of GJREQ structure */

/* Response: address of GJRESP structure */

#define     d_getjrnl(rds, p1, p2)\
        issue_svc(SVC_GET_JOUR_ATTR, (rds), (char *) (p1), (char *) (p2))

/* Report Journal Status */

typedef struct rjreq {            /* REPORT JOURNAL STATUS REQUEST   */
  NAME *name;                     /* Pointer to the journal name     */
  short buf_size;                 /* Reserved field that must be set */
                                  /* to zero.                        */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} RJREQ;

typedef struct rjresp {           /* REPORT JOURNAL STATUS RESPONSE  */
  long cur_size;                  /* The number of entries in the    */
                                  /* journal.                        */
  long jrn_size;                  /* Maximum number of journal       */
                                  /* entries allowed in the journal. */
  short largest_entry;            /* The largest entry in the journal*/
  short max_ent_size;             /* Maximum length of each journal  */
                                  /* entry.                          */
  char  deletable;                /* If true, it indicates whether   */
                                  /* that this Journal cannot be     */
                                  /* deleted.                        */
  char reserved1;                 /* Reserved; set to zero.          */
  short reserved2;                /* Reserved; set to zero.          */
  short reserved3;                /* Reserved; set to zero.          */
  unsigned char *addl_det;        /* Reserved; set to null.          */
  unsigned char *reserved4;       /* Reserved; must be NULL          */
} RJRESP;

/* Request:  address of RJREQ structure */

/* Response: address of RJRESP structure */

#define     d_jrnlstatus(rds, p1, p2)\
        issue_svc(SVC_REP_JOUR_STS, (rds), (char *) (p1), (char *) (p2))

/* Initialize Journal */

typedef struct ijreq {            /* INITIALIZE JOURNAL REQUEST      */
  NAME *name;                     /* Pointer to the journal name     */
  short limit_spec;               /* Specifies the criteria for      */
                                  /* initializing the journal        */
                                  /* contents.                       */
  GTRESP limit_time;              /* If limit_spec is TIME or        */
                                  /* TIME_ENTRY, this value specifies*/
                                  /* the time beyond which journal   */
                                  /* entries will not be deleted.    */
  char                            /*                                 */
    limit_entry[JRN_ENT_ID_LEN];  /* If limit_spec is ENTRY or       */
                                  /* TIME_ENTRY, this value specifies*/
                                  /* specifies the ENTRY_ID beyond   */
                                  /* which journal entries will not  */
                                  /* deleted.                        */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} IJREQ;

typedef struct ijresp {           /* INITIALIZE JOURNAL RESPONSE     */
  long  entries_del;              /* The number of journal entries   */
                                  /* that were deleted.              */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} IJRESP;

/*
** Constants used to define the initialize limit specification.
*/

#define IJ_NOLIMIT     0          /* Initialize entire journal       */
#define IJ_TIME_ENTRY  1          /* Initialize before specified time*/
                                  /* and entry id.                   */
#define IJ_RESEQUENCE  2          /* Resequence journal              */
#define IJ_ENTRY       3          /* Initialize before specified     */
                                  /* entry id.                       */
#define IJ_TIME        4          /* Initialize before specified time*/

/* Request:  address of IJREQ structure */

/* Response: address of IJRESP structure */

#define     d_initjrnl(rds, p1, p2)\
        issue_svc(SVC_INIT_JOURNAL, (rds), (char *) (p1), (char *) (p2))

/* Read Journal */

typedef struct rdjreq {           /* READ JOURNAL REQUEST            */
  NAME *name;                     /* Pointer to the journal name     */
  short range_start;              /* Specifies criteria for selecting*/
                                  /* the first journal entry.  It can*/
                                  /* have the values: NEWEST, OLDEST,*/
                                  /* TIME, or ENTRY.                 */
  GTRESP start_time;              /* When range start is TIME, this  */
                                  /* specifies the time to start     */
                                  /* reading.                        */
  char                            /*                                 */
    start_entry[JRN_ENT_ID_LEN];  /* If range start is ENTRY, this   */
                                  /* specifies the entry identifier  */
                                  /* to start reading.               */
  short range_stop;               /* Specifies criteria to stop      */
                                  /* reading journal entries.  It can*/
                                  /* have the values:  TIME, END,    */
                                  /* BEGINNING, and MAX_ENTRIES.     */
  long  nmbr_ent;                 /* When range stop is MAX_ENTRIES, */
                                  /* this specifies the number of    */
                                  /* entries to search.              */
  GTRESP end_time;                /* When range stop is TIME, this   */
                                  /* specifies the time after which  */
                                  /* to stop searching.              */
  short ent_start_after;          /* Specifies criteria for further  */
                                  /* qualifying the first entry      */
                                  /* returned.  It can have the      */
                                  /* values:  NONE, TIME, or ENTRY.  */
  GTRESP time_spec;               /* When ent to start after is TIME,*/
                                  /* this specifies a time as the    */
                                  /* starting point in returning     */
                                  /* qualified entries from a larger */
                                  /* list.                           */
  long ent_spec_offset;           /* When ent to start after is      */
                                  /* ENTRY, this specifies the entry */
                                  /* offset of the entry to start    */
                                  /* reading after.                  */
  char                            /*                                 */
   ent_spec_id[JRN_ENT_ID_LEN];   /* When ent to start after is      */
                                  /* ENTRY, this specifies the entry */
                                  /* id of the entry to start reading*/
                                  /* after.                          */
  char *orig_appl_nm;             /* Specifies an application name   */
                                  /* used to further qualify the     */
                                  /* entries to return.              */
  char *spec_appl_filter;         /* Reserved field that must be NULL*/
  char *var_name;                 /* Pointer to a buffer containing a*/
                                  /* comma separated, null terminated*/
                                  /* list of variable names used to  */
                                  /* further qualify the entries to  */
                                  /* return.                         */
  short buf_size;                 /* Specifies the size of the buffer*/
                                  /*  to receive journal entries.    */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} RDJREQ;

typedef struct rdjresp {          /* READ JOURNAL RESPONSE           */
  long  nmbr_ent;                 /* Contains the total number of    */
                                  /* entries that were returned.     */
  short more_fols;                /* If true, it indicates that more */
                                  /* journal entries matched the     */
                                  /* criteria but would not fit in   */
                                  /* buffer.                         */
  unsigned char *buffer;          /* Pointer to the user allocated   */
                                  /* data area containing the journal*/
                                  /* entry or entries.  The format of*/
                                  /* journal entries in the buffer is*/
                                  /* specified by the journal entry  */
                                  /* structures shown at the begin-  */
                                  /* ning of the journal section.    */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} RDJRESP;

/*
** Constants used to specify range start, range stop and entry to
** start after.
*/

#define RJ_NONE          0         /* No further filtering.           */
#define RJ_NEWEST        1         /* Most recent Journal entry       */
#define RJ_OLDEST        2         /* First journal entry             */
#define RJ_ENTRY         3         /* Entry ID is specified           */
#define RJ_TIME          4         /* Entry time stamp is specified   */
#define RJ_END           5         /* Stop at last journal entry      */
#define RJ_BEGINNING     6         /* Stop at first journal entry     */
#define RJ_MAX_ENTRIES   7         /* Stop after specifed # of entrys */

/* Request:  address of RDJREQ structure */

/* Response: address of RDJRESP structure */

#define     d_readjrnl(rds, p1, p2)\
        issue_svc(SVC_READ_JOURNAL, (rds), (char *) (p1), (char *) (p2))

/* Write Journal */


/*
** The following structure describes each variable (WJVARS) and is
** repeated for each variable that is to be part of the journal entry
** (when ent_form is DATA_FORM).  After the last variable, the var_name
** field must be set to NULL.
*/
typedef struct wjvars {           /* WRITE JOURNAL VARIABLE DESCRIPT.*/
  char *var_name;                 /* Pointer to a character string   */
                                  /* which specifies the name        */
                                  /* associated with this variable.  */
                                  /* When NULL this is the termina-  */
                                  /* ting variable descriptor.       */
  short var_type;                 /* Specifies the data type of this */
                                  /* variable.  See Define Remote    */
                                  /* Variable for valid types.       */
  short var_length;               /* Contains the length of the      */
                                  /* variable (in bytes).            */
  short var_elem;                 /* Contains the number of elements */
                                  /* of this var_type and var_length.*/
  unsigned char *var_value;       /* Pointer to a buffer of          */
                                  /* var_length*var_elem bytes which */
                                  /* contains the current value of   */
                                  /* this variable.                  */
} WJVARS;


typedef struct wjreq {            /* WRITE JOURNAL REQUEST           */
  NAME *name;                     /* Pointer to the journal name     */
  GTRESP time_stamp;              /* Specifies the date and time to  */
                                  /* be associated with the entry.   */
  unsigned char *addl_det;        /* Reserved. Must be NULL.         */
  char ent_form;                  /* Indicates the form of the       */
                                  /* journal entry. See journal entry*/
                                  /* structures above for valid      */
                                  /* values.                         */
  char reserved1;                 /* Reserved; must be zero.         */
  long reserved2;                 /* Reserved; must be zero.         */
  char *annotation;               /* Pointer to NULL terminated      */
                                  /* character string if ent_form =  */
                                  /* ANNOTATION_FORM; otherwise must */
                                  /* be NULL.                        */
  short data_len;                 /* Specifies the length of raw_data*/
                                  /* if ent_form = RAW_DATA_FORM;    */
                                  /* otherwise must be 0.            */
  unsigned char *raw_data;        /* Pointer to a buffer of dat_len  */
                                  /* bytes containing the journal    */
                                  /* entry data if ent_form =        */
                                  /* RAW_DATA_FORM; otherwise must   */
                                  /* be NULL.                        */
                                  /***********************************/
                                  /* The remaining fields are used   */
                                  /* ONLY if ent_form = DATA_FORM.   */
                                  /* NOTE: Do not use sizeof to calc-*/
                                  /* ulate the required memory size  */
                                  /* for this structure as var_list  */
                                  /* is an UNBOUNDED array!          */
                                  /***********************************/
  char *ev_nm;                    /* Pointer to a NULL terminated    */
                                  /* character string containing the */
                                  /* the name of the event condition */
                                  /* for which a state change has    */
                                  /* taken place.                    */
  char cur_state;                 /* Current state of the Event      */
                                  /* Condition; see Define Event for */
                                  /* valid values.                   */
  char reserved3;                 /* Reserved; must be zero.         */
  WJVARS var_list[1];             /* This field is an unbounded      */
                                  /* repeating structure of variable */
                                  /* descriptors.                    */
} WJREQ;

/*
** Constants used to interpret the os_code when user code is
** E_INVPARM.
*/

#define VAR_DES_SIZE  5           /* Number of parameters in WJVARS  */
#define VARLIST_POS   13          /* The paramter position of the    */
                                  /* first element in WJVARS.        */

/* Request:  address of WJREQ structure */

/* Response: none */

#define     d_writejrnl(rds, p1)\
        issue_svc(SVC_WRITE_JOURNAL, (rds), (char *) (p1), NULL)

/*ͻ
                        Polling Commands                       V1.1 
  ͼ*/

/* Start Variable Polling */

typedef struct strpreq {          /* START VARIABLE POLLING REQUEST  */
  char *var_name;                 /* Pointer to a buffer containing a*/
                                  /* comma separated, null terminated*/
                                  /* list of variable names to be    */
                                  /* polled.  It must not be null if */
                                  /* scope_start is SOS_SPECIFIC;    */
                                  /* otherwise, it must be null.     */
  short scope_start;              /* Indicates the scope of variables*/
                                  /* to be polled.                   */
  short buf_size;                 /* Size of variables not started   */
                                  /* buffer.                         */
#ifdef CS2CPLUSPLUS
  unsigned char *template_opt;    /* Pointer to the template buffer  */
#else
  unsigned char *template;        /* Pointer to the template buffer  */
#endif
                                  /* if the variable is a list       */
                                  /* otherwise, it must be null.     */
 } STRPREQ;

/* Scope of start valid values */
#define SOS_SPECIFIC  1           /* Start/stop specified names      */
#define SOS_LOCALS    2           /* Start/stop all locals           */
#define SOS_GLOBALS   3           /* Start/stop all globals          */
#define SOS_BOTH      4           /* Start/stop all locals & globals */

typedef struct strpresp {         /* START VARIABLE POLLING RESPONSE */
  short num_std;                  /* Indicates the number of         */
                                  /* variables that were added to    */
                                  /* the polling list.               */
  short num_not_std;              /* Indicates the number of         */
                                  /* variables that were not added   */
                                  /* to the polling list.            */
  char *var_not_std;              /* Pointer to a user allocated,    */
                                  /* list of variables that could    */
                                  /* not be started.                 */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} STRPRESP;

/* Request:  address of STRPREQ structure */

/* Response: address of STRPRESP structure */

#define     d_startpol(rds, p1, p2)\
        issue_svc(SVC_START_POLLING, (rds), (char *) (p1), (char *) (p2))

/* Stop Variable Polling */

typedef struct stppreq {          /* STOP VARIABLE POLLING REQUEST   */
  char *var_name;                 /* Pointer to a buffer containing a*/
                                  /* comma separated, null terminated*/
                                  /* list of variable names for      */
                                  /* polling should be stopped.  It  */
                                  /* must not be null if scope_stop  */
                                  /* is SOS_SPECIFIC; otherwise, it  */
                                  /* must be null.                   */
  short scope_stop;               /* Indicates the scope of variables*/
                                  /* to be polled.  See Start        */
                                  /* Variable Poller for valid values*/
  short buf_size;                 /* Size of variables not stopped   */
                                  /* buffer.                         */
  unsigned char *reserved;        /* Reserved; must be NULL          */
 } STPPREQ;

typedef struct stppresp {         /* STOP VARIABLE POLLING RESPONSE  */
  short num_stopped;              /* Indicates the number of         */
                                  /* variables that were removed from*/
                                  /* the polling list.               */
  short num_not_stopped;          /* Indicates the number of         */
                                  /* variables that were not removed */
                                  /* from the polling list.          */
  char *var_not_stopped;          /* Pointer to a user allocated,    */
                                  /* list of variables that could    */
                                  /* not be stopped.                 */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} STPPRESP;

/* Request:  address of STPPREQ structure */

/* Response: address of STPPRESP structure */

#define     d_stoppol(rds, p1, p2)\
        issue_svc(SVC_STOP_POLLING, (rds), (char *) (p1), (char *) (p2))

/*ͻ
                     Event Condition Commands                  V1.1 
  ͼ*/

/* Event Notification Message */

#define ENM_DATA_ALIGN_SIZE  4    /* Event notification message data */
                                  /* alignment size.                 */
#define ENM_CODE             85   /* Event notification message Code */

typedef struct notify_msg {       /* Event Notification Message      */
  long  msg_code;                 /* Identifies this message as an   */
                                  /* Event Notification Message.     */
  short log_dev_nm;               /* Offset to Logical device name   */
  short conn_nm;                  /* Offset to Connection name       */
                                  /* (if event is local).            */
  short appl_nm;                  /* Offset to Application name which*/
                                  /* owns the above connection (if   */
                                  /* event is local) or DDMS server  */
                                  /* name (if event is global).      */
  short ev_co_nm;                 /* Offset to Event condition name  */
                                  /***********************************/
                                  /* See Define Event Condition for  */
                                  /* for ranges and valid values of  */
                                  /* the following parameters:       */
  char  ev_co_scp;                /* Event condition scope           */
  char  reserved;                 /* Reserved                        */
  short severity;                 /* Event condition severity        */
#ifdef CS2CPLUSPLUS
  char  event_class;              /* Event Condition class           */
#else
  char  class;                    /* Event Condition class           */
#endif
  char  cur_state;                /* Current state of the event cond */
  short addl_det;                 /* Reserved                        */
  long  trns_second;              /* Time of this state transition   */
  short trns_millisecond;         /* in seconds and milliseconds.    */
  char  status;                   /* Status flags                    */
  char  caus_trns;                /* Causing state transition        */
  char  data[ENM_DATA_ALIGN_SIZE];/* Data area of this message. It   */
                                  /* contains all the variable name  */
                                  /* strings referenced by offsets   */
                                  /* above.                          */
} NOTIFY_MSG;

#define NM_NOT_LOST  0x01         /* Event notification lost         */

/* Wait For Condition */

typedef struct wtcreq {           /* WAIT FOR CONDITION REQUEST      */
  NAME *var_name;                 /* Remote variable name            */
#ifdef CS2CPLUSPLUS
  short comp_operator;            /* Operator to compare variable    */
                                  /* constant.                       */
#else
  short operator;                 /* Operator to compare variable    */
                                  /* constant.                       */
#endif
  short data_type;                /* Data type of the constant AND   */
                                  /* variable.  Only singular data   */
                                  /* types are supported (see Define */
                                  /* Remote Variable for valid       */
                                  /* types).  DT_PACKED_BOOLEAN and  */
                                  /* DT_TIME_ASCII are NOT supported.*/
  short data_len;                 /* Data length of the constant,    */
                                  /* in bytes.                       */
  char  *constant;                /* Pointer to data buffer contain- */
                                  /* ing the constant value of type  */
                                  /* and length specified above.     */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} WTCREQ;

/*
** Constants used to specify valid operators.
*/

#define LT          10            /* Less than (<)                   */
#define LE          11            /* Less than or equal to (<=)      */
#define GT          12            /* Greater than (>)                */
#define GE          13            /* Greater than or equal to (>=)   */
#define EQ          14            /* Equal to (=)                    */
#define NE          15            /* Not equal to (<> or !=)         */
#define ANYCHANGE   20            /* Anychange of the variable       */

/* Request:  address of WTCREQ structure */

/* Response: none */

#define     d_waitcon(rds, p1)\
        issue_svc(SVC_WAIT_FOR_COND, (rds), (char *) (p1), NULL)

/* Define Event Condition */

typedef struct decreq {           /* DEFINE EVENT CONDITION REQUEST  */
  NAME *name;                     /* Pointer to Event Condition name */
                                  /* string.                         */
  char scope;                     /* Scope of the Event Condition.   */
                                  /* See Define Journal for valid    */
                                  /* values.                         */
  char deletable;                 /* When true, it indicates that    */
                                  /* this Event Condition is not     */
                                  /* deletable.                      */
#ifdef CS2CPLUSPLUS
  char event_class;               /* Class of the Event Condition.   */
#else
  char class;                     /* Class of the Event Condition.   */
#endif
  char priority;                  /* Event priority.                 */
  short severity;                 /* Event severity.                 */
  char al_sum_rep;                /* Reserved; must be zero.         */
  char reserved1;                 /* Reserved; must be zero.         */
  unsigned char *addl_det;        /* Reserved; must be NULL.         */
  char *con_ref;                  /* Pointer to Event Condition      */
                                  /* expression string.              */
  char *notify;                   /* Pointer to ACB name or MCB name */
                                  /* that is to be notified upon     */
                                  /* event occurence.                */
  long eval_int;                  /* Reserved; must be zero.         */
  unsigned char *reserved2;       /* Reserved; must be NULL          */
} DECREQ;

/*
** Constants used to specify event condition class,
** state, priority, severity, transition and status fields.
** Note: See Remote Variable Commands for scope definitions.
*/

#define CLASS_MONITORED 1         /* Monitored event condition       */
#define CLASS_NETWORK   2         /* Network event condition         */

#define STATE_IDLE      0         /* Event state is idle (false)     */
#define STATE_ACTIVE    1         /* Event state is active (true)    */
#define STATE_UNDEFINED 2         /* Event state is undefined        */
#define STATE_DISABLED  3         /* Event is disabled               */
#define STATE_DELETED   4         /* Event is being deleted          */

#define PRIORITY_HI     0         /* Highest event priority          */
#define PRIORITY_LO     127       /* Lowest event priority           */

#define SEVERITY_HI     0         /* Highest event severity level    */
#define SEVERITY_LO     255       /* Lowest event severity level     */

#define TRANS_UNDEFINED       0   /* Event transitions which will    */
#define DISABLED_TO_ACTIVE    1   /* cause an application to be      */
#define DISABLED_TO_IDLE      2   /* notified.                       */
#define IDLE_TO_ACTIVE        3
#define IDLE_TO_DISABLED      4
#define ACTIVE_TO_IDLE        5
#define ACTIVE_TO_DISABLED    6
#define ANY_TO_DELETED        7
#define ANY_TO_UNDEFINED      8
#define UNDEFINED_TO_IDLE     9
#define UNDEFINED_TO_ACTIVE   10
#define UNDEFINED_TO_DISABLED 11

/* Request:  address of GECREQ structure */

/* Response: none */

#define     d_defecon(rds, p1)\
        issue_svc(SVC_DEF_EVENT_COND, (rds), (char *) (p1), NULL)

/* Delete Event Condition */

typedef struct dconreq {          /* DELETE EVENT CONDITION REQUEST  */
  char *name;                     /* Pointer to Event Condition Name */
                                  /* string.  This can be a comma    */
                                  /* separated list.                 */
  short scope_of_del;             /* Scope of delete.                */
  short buf_size;                 /* Size (in bytes) of the buffer   */
                                  /* pointed to by can_not_del.      */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} DCONREQ;

typedef struct dconresp {         /* DELETE EVENT CONDITION RESPONSE */
  short num_deleted;              /* Number of Event Conditions      */
                                  /* actually deleted.               */
  short num_not_del;              /* Number of Event Conditions not  */
                                  /* deleted.                        */
  char *can_not_del;              /* Name(s) of Event Condition      */
                                  /* objects not deleted.            */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} DCONRESP;

/*
** Constants used to specify the scope of delete.
*/

#define SOD_SPECIFIC 1            /* Delete specified names          */
#define SOD_LOCALS   2            /* Delete all locals               */
#define SOD_GLOBALS  3            /* Delete all globals              */
#define SOD_BOTH     4            /* Delete all locals & globals     */
#define SOD_NETWORK  5            /* Delete specified network events */

/* Request:  address of DCONREQ structure */

/* Response: address of DCONRESP structure */

#define     d_delecon(rds, p1, p2)\
       issue_svc(SVC_DEL_EVENT_COND, (rds), (char *) (p1), (char *) (p2))

/* Get Event Condition Attributes */

typedef struct gecreq {           /* GET EVENT CONDITION ATTR REQUEST*/
  NAME *name;                     /* Pointer to Event Condition name */
                                  /* structure.                      */
  short buf_size;                 /* Size (in bytes) of buffers      */
                                  /* pointed to by cond_ref and      */
                                  /* notify fields.                  */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} GECREQ;

typedef struct gecresp {          /* GET EVENT CONDITION ATTR RESP   */
                                  /***********************************/
                                  /* See Define Event Condition for  */
                                  /* valid values for the following: */
                                  /***********************************/
  char scope;                     /* Scope of the Event Condition.   */
                                  /* See Define Journal for valid    */
                                  /* values.                         */
  char deletable;                 /* When true, it indicates that    */
                                  /* this Event Condition is not     */
                                  /* deletable.                      */
#ifdef CS2CPLUSPLUS
  char event_class;               /* Class of the Event Condition.   */
#else
  char class;                     /* Class of the Event Condition.   */
#endif
  char priority;                  /* Event priority.                 */
  char al_sum_rep;                /* Reserved; must be zero.         */
  char reserved1;                 /* Reserved; must be zero.         */
  short severity;                 /* Event severity.                 */
  unsigned char *addl_det;        /* Reserved; must be NULL.         */
  char *con_ref;                  /* Pointer to Event Condition      */
                                  /* expression string.              */
  char *notify;                   /* Pointer to ACB name or MCB name */
                                  /* that is to be notified upon     */
                                  /* event occurence.                */
  long eval_int;                  /* Reserved; must be zero.         */
  unsigned char *reserved2;       /* Reserved; must be NULL          */
} GECRESP;

/* Request:  address of GECREQ structure */

/* Response: address of GECRESP structure */

#define     d_getecon(rds, p1, p2)\
       issue_svc(SVC_GET_EVENT_COND, (rds), (char *) (p1), (char *) (p2))

/* Report Event Condition Status */

typedef struct recsreq {          /* REPORT EVENT COND STATUS REQUEST*/
  NAME *name;                     /* Pointer to Event Condition name */
                                  /* structure.                      */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} RECSREQ;

typedef struct recsresp {         /* REPORT EVENT COND STATUS RESPONS*/
                                  /***********************************/
                                  /* See Define Event Condition for  */
                                  /* valid values for the following: */
                                  /***********************************/
  char state;                     /* Current state of the Event      */
                                  /* Condition.                      */
  char enabled;                   /* Enabled indicator. If true,     */
                                  /* event transitions will cause    */
                                  /* application notification.       */
  char scanning;                  /* Scanning indicator. If true,    */
                                  /* this event is currently being   */
                                  /* scanned.                        */
  char lst_trns;                  /* The last detected event state   */
                                  /* transition.  Undefined for      */
                                  /* CLASS_NETWORK events.           */
  GTRESP time_lst_trns;           /* Time the last transition (if    */
                                  /* any) occurred.                  */
  GTRESP lst_act_trns;            /* Time the last transition to     */
                                  /* STATE_ACTIVE occurred.          */
                                  /* Undefined for CLASS_NETWORK     */
                                  /* events.                         */
  GTRESP lst_idl_trns;            /* Time the last transition to     */
                                  /* STATE_IDLE occurred.  Undefined */
                                  /* for CLASS_NETWORK events.       */
  short reserved1;                /* Reserved; set to zero.          */
  short reserved2;                /* Reserved; set to zero.          */
  unsigned char *reserved3;       /* Reserved; must be NULL          */
} RECSRESP;

/* Request:  address of RECSREQ structure */

/* Response: address of RECSRESP structure */

#define     d_econstatus(rds, p1, p2)\
       issue_svc(SVC_REP_EVENT_COND, (rds), (char *) (p1), (char *) (p2))

/* Alter Event Condition Monitoring */

typedef struct altreq {           /* ALTER EVENT COND MONITORING REQ */
  NAME *name;                     /* Pointer to Event Condition name */
                                  /* structure.                      */
  char enabled;                   /* If true the event will be       */
                                  /* enabled. If enabled is not being*/
                                  /* changed, this must be set to    */
                                  /* NOCHANGE.                       */
  char priority;                  /* Specifies the new priority for  */
                                  /* this event.  If priority is not */
                                  /* being changed, this must be set */
                                  /* to NOCHANGE.                    */
  char al_sum_rep;                /* Reserved; must be zero.         */
  char state;                     /* Specifies the new state of the  */
                                  /* event.  If the state is not     */
                                  /* being changed, this must be     */
                                  /* NOCHANGE.                       */
  char *notify;                   /* Pointer to a Chestnut ACB or MCB*/
                                  /* queue name. If not being changed*/
                                  /* this must be NULL.  If notifica-*/
                                  /* tion is not desired this should */
                                  /* be set to point to a NULL string*/
  long eval_int;                  /* Reserved; must be zero.         */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} ALTREQ;

/*
** Constant used to specify no change of an attribute.
*/

#define NOCHANGE -1               /* Do not change this attribute    */

/* Request:  address of ALTREQ structure */

/* Response: none */

#define     d_altecon(rds, p1)\
        issue_svc(SVC_ALTER_EVENT_COND, (rds), (char *) (p1), NULL)

/* Trigger Event */

typedef struct trigreq {          /* TRIGGER EVENT REQUEST           */
  NAME *name;                     /* Pointer to Event Condition name */
                                  /* structure.                      */
  char priority;                  /* Specifies the new priority for  */
                                  /* this event.  If priority is not */
                                  /* being changed, this must be set */
                                  /* to NOCHANGE.                    */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} TRIGREQ;

/* Request:  address of TRIGREQ structure */

/* Response: none */

#define     d_trigecon(rds, p1)\
        issue_svc(SVC_TRIGGER_EVENT, (rds), (char *) (p1), NULL)

/* Start Event Scanner */

typedef struct strsreq {          /* START EVENT SCANNER REQUEST     */
  char *evt_name;                 /* Pointer to a buffer containing  */
                                  /* event name(s) to be scanned.    */
  short scope_start;              /* Indicates the scope of events to*/
                                  /* events to be started.  See Start*/
                                  /* Variable Poller for valid values*/
  short buf_size;                 /* The size of the buffer that will*/
                                  /* be used to return the list of   */
                                  /* requested events that could not */
                                  /* be started.                     */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} STRSREQ;

typedef struct strsresp {         /* START EVENT SCANNER RESPONSE    */
  short num_std;                  /* The number of events for which  */
                                  /* the scanner could be started.   */
  short num_not_std;              /* The number of events for which  */
                                  /* the scanner could not be started*/
  char *buffer;                   /* Buffer used to return the names */
                                  /* of events which could not be    */
                                  /* started.  The buffer will be    */
                                  /* filled to buf_siz.  When full   */
                                  /* the request will continue and   */
                                  /* update the counters above, but  */
                                  /* not put the names in this buffer*/
  unsigned char *reserved;        /* Reserved; must be NULL          */
} STRSRESP;

/* Request:  address of STRSREQ structure */

/* Response: address of STRSRESP structure */

#define     d_startscan(rds, p1, p2)\
        issue_svc(SVC_START_SCAN, (rds), (char *) (p1), (char *) (p2))

/* Stop Event Scanner */

typedef struct stopreq {          /* STOP EVENT SCANNER REQUEST      */
  char *evt_name;                 /* Pointer to a buffer containing  */
                                  /* event name(s) to stop scanning. */
  short scope_stop;               /* Indicates the scope of events to*/
                                  /* events to be stopped.  See Start*/
                                  /* Variable Poller for valid values*/
  short buf_size;                 /* The size of the buffer that will*/
                                  /* be used to return the list of   */
                                  /* requested events that could not */
                                  /* be stopped.                     */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} STOPREQ;

typedef struct stopresp {         /* STOP EVENT SCANNER RESPONSE     */
  short num_stp;                  /* The number of events for which  */
                                  /* the scanner could be stopped.   */
  short num_not_stp;              /* The number of events for which  */
                                  /* the scanner could not be stopped*/
  char *buffer;                   /* Buffer used to return the names */
                                  /* of events which could not be    */
                                  /* stopped.  The buffer will be    */
                                  /* filled to buf_siz.  When full   */
                                  /* the request will continue and   */
                                  /* update the counters above, but  */
                                  /* not put the names in this buffer*/
  unsigned char *reserved;        /* Reserved; must be NULL          */
} STOPRESP;

/* Request:  address of STOPREQ structure */

/* Response: address of STOPRESP structure */

#define     d_stopscan(rds, p1, p2)\
        issue_svc(SVC_STOP_SCAN, (rds), (char *) (p1), (char *) (p2))

/* Wait On Change */

typedef struct wocreq {           /* WAIT ON CHANGE REQUEST          */
  NAME *var_name;                 /* Pointer to variable name        */
                                  /* structure.                      */
  GTRESP start_time;              /* Time value to be compared       */
                                  /* against the variable's time     */
                                  /* stamp.                          */
  short buf_size;                 /* Maximum size of receive buffer. */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} WOCREQ;

typedef struct wocresp {          /* WAIT ON CHANGE RESPONSE         */
  short data_type;                /* Type of data returned.          */
  short data_len;                 /* Element length in bytes.        */
  short number_elem;              /* Number of elements in variable. */
  unsigned char *data_buff;       /* Pointer to user allocated buffer*/
                                  /* of data_len*number_elem length. */
  GTRESP time_stamp;              /* Variable time stamp.            */
  unsigned char *reserved;        /* Reserved; must be NULL          */
} WOCRESP;

/* Request:  address of WOCREQ structure */

/* Response: address of WOCRESP structure */

#define     d_waitchg(rds, p1, p2)\
        issue_svc(SVC_WAIT_CHANGE, (rds), (char *) (p1), (char *) (p2))

/*ͻ
               Variable Message Processing                     V1.2 
  ͼ*/

#define VNM_CODE           86
#define VNM_ERROR          87
#define VNM_POLL_MISSED    88
#define VNM_STATUS         89
#define VNM_STATUS_N_DATA  90

/********************* Start Message Service  *************************/

typedef struct strmreq   {        /* START MESSAGE SERVICE REQUEST  */
  short scope_start;              /* Indicates the scope of variables*/
                                  /* to be started.                  */
  char *notify;                   /* ACB or MCB name that is to be   */
                                  /* sent the variable notification  */
                                  /* when a change in the variable's */
                                  /* data is detected.               */
  char *var_name;                 /* Pointer to a buffer containing a*/
                                  /* comma separated, null terminated*/
                                  /* list of variable names to be    */
                                  /* started.  It must not be null if*/
                                  /* scope_start is SOR_SPECIFIC;    */
                                  /* otherwise, it must be null.     */
  short buf_size;                 /* Size of variables not started   */
                                  /* buffer.                         */
  short format;                   /* Indicates variable message      */
                                  /* data format.                    */
  short ack;                      /* Indicates message with or       */
                                  /* without acknowledgement         */
  short notify_option;            /* Indicates notification criteria */
  unsigned char *reserved;        /* Reserved; Must be NULL.         */
 } STRMREQ;

/* Scope of registration valid values */
#define SOR_SPECIFIC       1    /* Start/stop specified names */
#define SOR_ALL_SOL        2    /* Start/stop all vars        */
#define SOR_ALL_UNSOL      3    /* Start/stop all unsol vars  */
#define SOR_BOTH           4    /* Start/stop all sol vars    */

/* Valid format values */
#define FOR_PACKED         0
#define FOR_INDEXED        1

/* Valid ack values */
#define ACK_NO             0
#define ACK_YES            1

/* Valid notification option values */
#define OPT_ON_DATA_CHANGE 0
#define OPT_ON_VAR_READ    1
#define VAR_STATUS_CHANGE  4
#define POLL_MESSAGE_REQ   8

typedef struct strmresp   {       /* START MESSAGE SERVICE RESPONSE */
  short num_std;                  /* Indicates the number of         */
                                  /* variables that were started.  . */
  short num_not_std;              /* Indicates the number of         */
                                  /* variables that were not         */
                                  /* started.                        */
  char *var_not_std;              /* Pointer to a user allocated,    */
                                  /* list of variables that could    */
                                  /* not be started.                 */
  unsigned char *reserved;        /* Reserved; Must be NULL.         */
} STRMRESP;

#define     d_startmsg(rds, p1, p2)\
    issue_svc(SVC_START_MSG, (rds), (char *) (p1), (char *) (p2))

/********************* Stop Message Service ***************************/

typedef struct stpmreq    {       /* STOP MESSAGE SERVICE REQUEST   */
  short scope_stop;               /* Indicates the scope of variables*/
                                  /* to be stopped.       See Start  */
                                  /* Message Service for valid values*/
  char *notify;                   /* ACB or MCB name that is no longer */
                                  /* to be sent a variable notification */
                                  /* when a change is the variable's */
                                  /* data is detected.               */
  char *var_name;                 /* Pointer to a buffer containing a*/
                                  /* comma separated, null terminated*/
                                  /* list of variable names to be    */
                                  /* stopped. It                     */
                                  /* must not be null if scope_stop  */
                                  /* is SOR_SPECIFIC; otherwise, it  */
                                  /* must be null.                   */
  short buf_size;                 /* Size of variables not stopped   */
                                  /* buffer.                         */
  unsigned char *reserved;        /* Reserved; Must be NULL.         */
 } STPMREQ;

typedef struct stpmresp   {       /* STOP MESSAGE SERVICE RESPONSE  */
  short num_stp;                  /* Indicates the number of         */
                                  /* variables that were stopped     */
  short num_not_stp;              /* Indicates the number of         */
                                  /* variables that were not         */
                                  /* stopped.                        */
  char *var_not_stp;              /* Pointer to a user allocated,    */
                                  /* list of variables that could    */
                                  /* not be stopped.                 */
  unsigned char *reserved;        /* Reserved; Must be NULL.         */
} STPMRESP;

#define     d_stopmsg(rds, p1, p2)\
    issue_svc(SVC_STOP_MSG, (rds), (char *) (p1), (char *) (p2))

/*********** Variable Notification ***********************************/

#define TRIGGERED_BY_APPLIC_READ  0
#define TRIGGERED_BY_APPLIC_WRITE 1
#define TRIGGERED_BY_UNSOL_MSG    2
#define TRIGGERED_BY_DDMS_READ    3

typedef struct notify_vn_msg {    /* Variable Notification Message   */
  long  msg_code;                 /* Identifies this message as an   */
                                  /* Variable Notification Message   */
  long  second;                   /* Variable change time in seconds */
  short millisecond;              /* Variable change time in milliseconds */
  short scope;                    /* Variable scope                  */
  short data_type;                /* Variable data type              */
  short length;                   /* Variable data element length    */
  short number;                   /* Variable number of elements     */
  short num_reps;                 /* Number of repitions             */
  short array_indx;               /* Array index                     */
                                  /* TRUE  = index & data            */
                                  /* FALSE = data only               */
  char  trigger_type;             /* How notification was triggered  */
  char  reserved;                 /* Reserved.                       */
} NOTIFY_VN_MSG;


/*ͻ
                       Support      Commands                        
  ͼ*/

/* Input */

typedef struct inputresp {         /* Input response structure   */
  short actual_size;               /* Actual bytes transmitted   */
  char *bfr_addr;                  /* Input buffer address       */
} INPUTRESP;

/* Request:  pointer(address) to short(input buffer size) */

/* Response: address of INPUTRESP structure */

#define     d_input(rds, p1, p2)\
        issue_svc(SVC_KBD_INPUT, (rds), (char *) (p1), (char *) (p2))

/* Output */

/* Request:  pointer to output data buffer */

/* Response: none */

#define     d_output(rds, p1)\
        issue_svc(SVC_CON_DISPLAY, (rds), (char *) (p1), NULL)

/* load header */

/* Valid load header request mode types */

#define NORMAL         0
#define NO_LOAD        1           /* Do not define a load configuration */

typedef struct ldhdreq {           /* Load header request list */
  char *filenm;                    /* Ptr to (path/)name of header file */
  short bfr_size;                  /* Response buffer size */
  short mode;                      /* Mode of operation */
} LDHDREQ;

typedef struct ldhdr_resp_struct {
  char  *response;              /* pointer to a buffer containing string data*/
  short actual;                 /* size of returned response data.           */
  short user_count;             /* number of user's in header file           */
  long  checksum;               /* 32 bit checksum                           */
  short region_count;           /* number of regions                         */
} LDHDRESP;
#define     d_ldhdr(rds, p1, p2)\
   issue_svc(SVC_LOAD_HEADER, (rds),(char *) (p1), (char *)(p2))

/* save header */

/* Valid save header request command types */

#define HDR_CREATE         0
#define HDR_UPDATE         1
#define HDR_COPY           2

typedef struct svhdreq {           /* Save header request structure */
  char *device_name;               /* Device name */
  char *device_type;               /* Device type */
  char *filenm;                    /* Ptr to (path/)name of header file */
  char *user_id;                   /* User ID to add - if any */
  char *config_name;               /* Ptr to configuration name */
  long checksum;                   /* Checksum of data file */
  short cmd;                       /* UPLOAD/DOWNLOAD/CREATE */
  char *cmd_string;                /* string for header command field */
} SVHDREQ;

#define     d_svhdr(rds, p1)\
        issue_svc(SVC_SAVE_HEADER, (rds),(char *) (p1), NULL)

/* mem status */

#define REL_GARBAGE 1

typedef struct mstatreq {          /* Memstat request structure    */
  short type;                      /* Memstat option               */
} MXREQ;

typedef struct mstatresp {         /* Memstat response structure   */
  long  alloc;                     /* Number of outstanding allocs */
  long  totmem;                    /* Total amount of memory       */
  long  availmem;                  /* Amt of available memory      */
  long  contmem;                   /* Amt of largest contig memory */
  long  deallocerr;                /* Number of dealloc errors     */
} MXRESP;

#define     d_memstat(rds, p1,p2)\
        issue_svc(SVC_MEMSTAT, (rds), (char *)(p1), (char *)(p2))

/* Set memory  */

typedef struct getmemreq{       /* get memory request structure */
  long size;                    /* size of additional memory */
} GETMEMREQ;

#define     d_setmem(rds,p1)\
        issue_svc(SVC_SETMEM, (rds), (char*)(p1), NULL)

/* start measurement */

#define     d_measstrt(rds)\
        issue_svc(SVC_MEASSTRT, (rds), NULL, NULL)

/* stop measurement */

typedef struct measresp{         /* measurement results */
      long peak;        /* peak memory used */
      long elapsed;     /* elapsed time in milliseconds */
      long reserved;
} MEASRESP;

#define     d_measstop(rds,p1,p2)\
        issue_svc(SVC_MEASSTOP, (rds), NULL, (char*)(p2) )

/* wait for resource change */

#define     d_waitres(rds,p1)\
        issue_svc(SVC_WAITRES, (rds), (char*)(p1), NULL)

/* SIZEOF      */

typedef struct sizreq {           /* sizeof request structure         */
  NAME *varnm;                    /* Variable name structure          */
  short resp_name_len;            /* Size of last_read string in      */
                                  /* response structure               */
} SIZREQ;

typedef struct sizresp {          /* sizeof request structure         */
  long size;                      /* size of the variable             */
  char *last_read;                /* name of last variable read       */
} SIZRESP;

#define     d_sizeof(rds,p1,p2)\
        issue_svc(SVC_SIZEOF, (rds), (char *)(p1), (char *)(p2))

/* PURGE_USER  */

void d_purge_user(RDS *rds);

/*ͻ
                     End   of   Declaration   File                  
  ͼ*/

#ifdef CS2CPLUSPLUS
}
#endif

#endif
